; Programme de compression
; Mettre dans file_length la longueur du fichier a compresser
; , dans file_name le nom du fichier a compresser, et enfin
; dans packedfile_name le nom du fichier compress.

file_length	equ	32000

;***********
Section TEXT
;***********
main:
 movem.l	d0-d7/a0-a6,-(sp)
 movea.l	#bk_occurences,a0
 move.l	#fin_section_bss,d0
 sub.l		a0,d0
init_bss_section:		; On initialise section BSS.
 move.b	#$00,(a0)+	; On remplit avec des 0.
 dbra		d0,init_bss_section
chargement_fichier:		; On le met dans #megabuffer+$2000.
 move.w	#0,-(sp)
 move.l	#file_name,-(sp)
 move.w	#$3d,-(sp)	; Ouverture fichier en lecture.
 trap		#1
 addq.l	#$8,sp
 move.w	d0,d7		; Numero de canal.
 move.l	#megabuffer+$2000,-(sp)
 move.l	#file_length,-(sp)
 move.w	d7,-(sp)
 move.w	#$3f,-(sp)	; Lecture du fichier.
 trap		#1
 add.l		#12,sp
 move.w	d7,-(sp)
 move.w	#$3e,-(sp)	; Fermeture du fichier.
 trap		#1
 addq.l	#4,sp

;****************
occurences_table:		; Construction table des occurences.
 move.l	#megabuffer+$2000,a0
 move.l	#bk_occurences,a1
 move.l	#file_length,d0
 subi.l	#1,d0	
count_each_byte:
 clr.l		d1
 move.b	(a0)+,d1	; Plus 4*la valeur dans a0.
 rol.l		#2,d1		; Multiplication par 4.
 addi.l	#1,$0(a1,d1)
 dbra		d0,count_each_byte 	
	
;************
huffman_tree:			; Construction des noeuds.
 move.l	#knots,a0
 move.l	#bk_occurences,a1
 clr.l		d5		; D5 utilise comme knot_index.
tant_que:
 bsr		bk_min_search ; Recherche bk_min.
 bsr		bk_max_search ; Recherche bk_max.
 move.w	bk_min,d7
 move.w	bk_max,d6
 cmp.w		d6,d7		; Tant que bk_min <> bk_max.
 beq		fin_hufftree
 move.w	d7,$2(a0,d5)	; Bk_min dans knots+knot_index+2.
 move.l	d5,d4
 addi.l	#$400,d4	; Bk_occurences+bk_min dans
 move.l	$0(a1,d7),(a1,d4)	; bk_occurences+knot_index+1024.	
 move.l	#$0,$0(a1,d7)	; 0 dans bk_occurences+bk_min.	
 bsr		bk_min_search ; Recherche bk_min.
 move.w	bk_min,d7
 move.w	d7,$0(a0,d5)	; Bk_min dans knots+knot_index.
 move.l	(a1,d4),d3	; Bk_occurences+bk_min ajoute dans
 add.l		$0(a1,d7),d3	; bk_occurences+knot_index+1024.
 move.l	d3,$0(a1,d5)
 move.l	#$0,$0(a1,d7)	; 0 dans bk_occurences+bk_min.	
 addi.l	#$4,d5		; Knot suivant.
 bra		tant_que
fin_hufftree:


fin_prog:
 movem.l	(sp)+,d0-d7/a0-a6
 clr.w		-(sp)
 trap		#1

;***************
bk_min_search:
 movem.l	d0-d2/a0-a1,-(sp)
 move.l	#$1ff,d0	; Recherche sur 511 bk.
 move.l	#bk_occurences,a0
 move.l	#$ffffff,d1
search_min:
 move.l	(a0),d2
 cmpi.l	#$0,d2		; Les bk d'occurence nulle ne
 beq		pasmin		; sont pas pris en compte.
 cmp.l		d1,d2
 bge		pasmin		; D2 < d1
 move.l	d2,d1		; Si oui alors
 move.l	a0,a1		; Bk_min <- a0-#bk_occurences et d2
 suba.l	#bk_occurences,a1	; prend la plus petite valeur.
 move.w	a1,bk_min	
pasmin:
 adda.l	#$4,a0		; Bk_suivant.
 dbra		d0,search_min
 movem.l	(sp)+,d0-d2/a0-a1
 rts

;***************
bk_max_search:
 movem.l	d0-d2/a0-a1,-(sp)
 move.l	#$1ff,d0	; Recherche sur 511 bk.
 move.l	#bk_occurences,a0	
 clr.l		d1
search_max:
 move.l	(a0),d2
 cmp.l		d1,d2
 blt		pasmax		; D2 >= d1
 move.l	d2,d1		; Si oui alors
 move.l	a0,a1		; Bk_max <- a0-#bk_occurences et d2
 suba.l	#bk_occurences,a1	; prend la plus grande valeur.
 move.w	a1,bk_max	
pasmax:
 adda.l	#$4,a0		; Bk suivant.		
 dbra		d0,search_max
 movem.l	(sp)+,d0-d2/a0-a1
 rts


;***********
Section DATA
;***********
file_name:
 dc.b		'a:1.img'
packedfile_name:
 dc.b		'a:1.pak'

;**********
Section BSS
;**********
even
bk_occurences:		; Occurences des bytes et knots.
 ds.l		512		
knots:				; Upperword: byte ou knot fort.
 ds.l		256		; Lowerword: byte ou knot faible.
bk_min:			; Index du byte ou knot de plus
 ds.w		1		; faible occurence.
bk_max:			; Index du byte ou knot de plus
 ds.w		1		; forte occurence.
knot_index:			; Knot courant.
 ds.w		1
fin_section_bss:		; Aide pour initialisation de Section BSS
 ds.w		1
megabuffer:			; Megabuffer,qui contient les donnees.
 ds.l		1		
