; Programme de compression
; Mettre dans file_length la longueur du fichier a compresser
; , dans file_name le nom du fichier a compresser, et enfin
; dans packedfile_name le nom du fichier compress.

file_length	equ	32000

;***********
Section TEXT
;***********
main:
 movem.l	d0-d7/a0-a6,-(sp)
 movea.l	#bk_occurences,a0
 move.l	#fin_section_bss,d0
 sub.l		a0,d0
init_bss_section:		; On initialise section BSS.
 move.b	#$00,(a0)+	; On remplit avec des 0.
 dbra		d0,init_bss_section
chargement_fichier:		; On le met dans #megabuffer+$2000.
 move.w	#0,-(sp)
 move.l	#file_name,-(sp)
 move.w	#$3d,-(sp)	; Ouverture fichier en lecture.
 trap		#1
 addq.l	#$8,sp
 move.w	d0,d7		; Numero de canal.
 move.l	#megabuffer+$2000,-(sp)
 move.l	#file_length,-(sp)
 move.w	d7,-(sp)
 move.w	#$3f,-(sp)	; Lecture du fichier.
 trap		#1
 add.l		#12,sp
 move.w	d7,-(sp)
 move.w	#$3e,-(sp)	; Fermeture du fichier.
 trap		#1
 addq.l	#4,sp

;****************
occurences_table:		; Construction table des occurences.
 move.l	#megabuffer+$2000,a0
 move.l	#bk_occurences,a1
 move.l	#file_length,d0
 subi.l	#1,d0	
count_each_byte:
 clr.l		d1
 move.b	(a0)+,d1	; Plus 4*la valeur dans a0.
 rol.l		#2,d1		; Multiplication par 4.
 addi.l	#1,$0(a1,d1)
 dbra		d0,count_each_byte 	
	
;************
huffman_tree:			; Construction des noeuds.
 move.l	#knots,a0
 move.l	#bk_occurences,a1
 clr.l		d5		; D5 utilise comme knot_index.
 clr.l		d6
 clr.l		d7

tant_que:
 bsr		bk_min_search ; Recherche bk_min.
 bsr		bk_max_search ; Recherche bk_max.
 move.w	bk_min,d7
 move.w	bk_max,d6
 cmp.w		d6,d7		; Tant que bk_min <> bk_max.
 beq		fin_hufftree
 lsr.l		#$2,d7		; Division par 4.
 move.w	d7,$2(a0,d5)	; Bk_min dans knots+knot_index+2.
 lsl.l		#$2,d7		; Multiplication par 4.
 move.l	d5,d4
 addi.l	#$400,d4
 move.l	$0(a1,d7),d3	; Bk_occurences+bk_min dans d3.	
 move.l	#$0,$0(a1,d7)	; 0 dans bk_occurences+bk_min.	
 bsr		bk_min_search ; Recherche bk_min.
 move.w	bk_min,d7
 lsr.l		#$2,d7		; Division par 4.
 move.w	d7,$0(a0,d5)	; Bk_min dans knots+knot_index.
 lsl.l		#$2,d7		; Multiplication par 4.
 add.l		$0(a1,d7),d3	; Bk_occurences+bk_min+d3 dans
 move.l	d3,$0(a1,d4)	; bk_occurences+knot_index+1024.
 move.l	#$0,$0(a1,d7)	; 0 dans bk_occurences+bk_min.	
 addi.l	#$4,d5		; Knot suivant.
 bra		tant_que
fin_hufftree:
 subi.l	#$4,d5
 move.w	d5,knot_index


;******************
attribution_codage:		; Utilisation d'une boucle recursive.
 move.w	#$ffff,nb_bits
 bsr		codage_recursif

;************
packing_file:			; Cette fois ca y est, on attaque.
 move.l	#megabuffer,a0
 move.l	a0,a1		; Adresse du fichier packe dans a1.
 adda.l	#$2000,a0	; Adresse du fichier non packe dans a0.
 move.l	#bytes_codages,a2	; Adresse des codages dans a2.
 clr.l		d0	; Nombre de bits du fichier packe dans d0 mod(8).
 move.l	#file_length,d7	; Nombre d' octets a coder,
 subi.l	#1,d7		; -1 a cause de la boucle.
coding_a_byte:
 clr.l		d1
 move.b	(a0)+,d1	; Byte que l' on va coder.
 mulu.w	#$12,d1	; 18 bytes par codage d' octet.
 move.l	a2,a3
 adda.l	d1,a3		; A3 pointe maintenant sur le codage du byte.
 move.w	(a3)+,d2	; Nb de bits du codage du byte.
 clr.l		d3		; Compteur du nombre de bytes.
bit_per_bit:
 move.l	#$7,d4
 sub.l		d3,d4		; On teste d' abord les upperbits.
 btst.b	d4,(a3)	; On teste le bit.
 bne		set_bit	; Est il allume?
clear_bit:			; Non
 move.l	#$7,d4		
 sub.l		d0,d4		; On remplit d' abord les upperbits.
 bclr.b	d4,(a1)	; On clear le bit.
 addi.l	#$1,d0		; Index de bits incremente.
 cmpi.l	#$8,d0		; 8 bits?
 bne		pas_8_bits
 clr.l		d0		; Oui alors on incremente a1 et on clear d0.
 adda.l	#$1,a1
pas_8_bits:
 bra		bit_suivant
set_bit:			; Bit allume.
 move.l	#$7,d4		
 sub.l		d0,d4		; On remplit d' abord les upperbits.
 bset.b	d4,(a1)	; On set le bit.
 addi.l	#$1,d0		; Index de bits incremente.
 cmpi.l	#$8,d0		; 8 bits?
 bne		bit_suivant
 clr.l		d0		; Oui alors on incremente a1 et on clear d0.
 adda.l	#$1,a1
bit_suivant:
 addi.l	#$1,d3		; Index de bits incremente.
 cmp.l		d2,d3		; As t' on place tous les bits?
 beq		next_byte	; Sinon on continue.
 cmpi.l	#$8,d3		; 8 bits?
 bne		pas_8_bits_2
 clr.l		d3		; Oui alors on incremente a1 et on clear d0.
 adda.l	#$1,a3
 subi.l	#$8,d2		; Mais on doit aussi penser a d2.
pas_8_bits_2:
 bra		bit_per_bit
next_byte:
 dbra		d7,coding_a_byte	; On code tous les bytes.


 	


fin_prog:
 movem.l	(sp)+,d0-d7/a0-a6
 clr.w		-(sp)
 trap		#1

;*************
bk_min_search:
 movem.l	d0-d2/a0-a1,-(sp)
 move.l	#$1ff,d0	; Recherche sur 511 bk.
 move.l	#bk_occurences,a0
 move.l	#$ffffff,d1
search_min:
 move.l	(a0),d2
 cmpi.l	#$0,d2		; Les bk d'occurence nulle ne
 beq		pasmin		; sont pas pris en compte.
 cmp.l		d1,d2
 bge		pasmin		; D2 < d1
 move.l	d2,d1		; Si oui alors
 move.l	a0,a1		; Bk_min <- a0-#bk_occurences et d2
 suba.l	#bk_occurences,a1	; prend la plus petite valeur.
 move.w	a1,bk_min	
pasmin:
 adda.l	#$4,a0		; Bk_suivant.
 dbra		d0,search_min
 movem.l	(sp)+,d0-d2/a0-a1
 rts

;*************
bk_max_search:
 movem.l	d0-d2/a0-a1,-(sp)
 move.l	#$1ff,d0	; Recherche sur 511 bk.
 move.l	#bk_occurences,a0	
 clr.l		d1
search_max:
 move.l	(a0),d2
 cmp.l		d1,d2
 blt		pasmax		; D2 >= d1
 move.l	d2,d1		; Si oui alors
 move.l	a0,a1		; Bk_max <- a0-#bk_occurences et d2
 suba.l	#bk_occurences,a1	; prend la plus grande valeur.
 move.w	a1,bk_max	
pasmax:
 adda.l	#$4,a0		; Bk suivant.		
 dbra		d0,search_max
 movem.l	(sp)+,d0-d2/a0-a1
 rts

;***************
codage_recursif:
 addi.w	#$1,nb_bits	; Incrementation du nombre de bits.
lowerword_case:
 clr.l		d0		
 move.w	nb_bits,d0	
 move.l	#byte_codage,a0
 move.l	d0,d1				
 lsr.l		#$3,d0		; On met int(nb_bits/8) dans d0,
 adda.w	d0,a0		; et on l' additionne a #byte_codage.
 lsl.l		#$3,d0
 sub.w		d0,d1		; On met nb_bits mod(8) dans d1.
 move.l	#$7,d2		; On prend 7-d1 afin de commencer
 sub.b		d1,d2		; le remplissage par les upperbits.
 bclr.b	d2,(a0)   	; Enfin on clear le bit concerne.
lowerword_inf_256:
 clr.l		d0
 move.l	#knots,a0
 move.w	knot_index,d0
 clr.l		d1
 move.w	$2(a0,d0),d1	; On met lowerword de knot+knot_index dans d1.
 cmpi.w	#255,d1
 bgt		lowerword_sup_255
 move.l	#bytes_codages,a0
 mulu.w	#$12,d1	; 18 bytes par byte code.	
 adda.l	d1,a0		; A0 pointe sur bytes_codages+byte_index.
 move.l	#byte_codage,a1
 move.w	nb_bits,d2	; Ici on ajoute 1 a nb_bits car on a
 addi.w	#$1,d2		; en fait utilise nb_bits-1 plus haut.	
 move.w	d2,(a0)+	; On recopie ce qui nous interesse sur
 move.l	(a1)+,(a0)+	; le codage du byte dans a0.
 move.l	(a1)+,(a0)+
 move.l	(a1)+,(a0)+
 move.l	(a1)+,(a0)+
 bra		upperword_case
lowerword_sup_255:
 move.w	knot_index,-(sp)	; On met knot_index dans -(sp).
 subi.w	#$100,d1	; On met lowerword de knot+knot_index -$100
 lsl.l		#$2,d1		; multiplie par 4 dans knot_index.
 move.w	d1,knot_index 	
 bsr		codage_recursif	; Appel recursif.
 move.w	(sp)+,knot_index	; On restaure knot_index.		
upperword_case:
 clr.l		d0		
 move.w	nb_bits,d0	
 move.l	#byte_codage,a0
 move.l	d0,d1				
 lsr.l		#$3,d0		; On met int(nb_bits/8) dans d0,
 adda.w	d0,a0		; et on l' additionne a #byte_codage.
 lsl.l		#$3,d0
 sub.w		d0,d1		; On met nb_bits mod(8) dans d1.
 move.l	#$7,d2		; On prend 7-d1 afin de commencer
 sub.b		d1,d2		; le remplissage par les upperbits.
 bset.b	d2,(a0)   	; Enfin on set le bit concerne.
upperword_inf_256:
 clr.l		d0
 move.l	#knots,a0
 move.w	knot_index,d0
 clr.l		d1
 move.w	$0(a0,d0),d1	; On met upperword de knot+knot_index dans d1.
 cmpi.w	#255,d1
 bgt		upperword_sup_255
 move.l	#bytes_codages,a0
 mulu.w	#$12,d1	; 18 bytes par byte code.	
 adda.l	d1,a0		; A0 pointe sur bytes_codages+byte_index.
 move.l	#byte_codage,a1
 move.w	nb_bits,d2	; Ici on ajoute 1 a nb_bits car on a
 addi.w	#$1,d2		; en fait utilise nb_bits-1 plus haut.	
 move.w	d2,(a0)+	; On recopie ce qui nous interesse sur
 move.l	(a1)+,(a0)+	; le codage du byte dans a0.
 move.l	(a1)+,(a0)+
 move.l	(a1)+,(a0)+
 move.l	(a1)+,(a0)+
 bra		fin_codage
upperword_sup_255:
 move.w	knot_index,-(sp)	; On met knot_index dans -(sp).
 subi.w	#$100,d1	; On met lowerword de knot+knot_index -$100
 lsl.l		#$2,d1		; multiplie par 4 dans knot_index.
 move.w	d1,knot_index 	
 bsr		codage_recursif	; Appel recursif.
 move.w	(sp)+,knot_index	; On restaure knot_index.		
fin_codage:
 clr.l		d0		; On va clearer le dernier bit.		
 move.w	nb_bits,d0	
 move.l	#byte_codage,a0
 move.l	d0,d1				
 lsr.l		#$3,d0		; On met int(nb_bits/8) dans d0,
 adda.w	d0,a0		; et on l' additionne a #byte_codage.
 lsl.l		#$3,d0
 sub.w		d0,d1		; On met nb_bits mod(8) dans d1.
 move.l	#$7,d2		; On prend 7-d1 afin de commencer
 sub.b		d1,d2		; le remplissage par les upperbits.
 bclr.b	d2,(a0)   	; Enfin on clear le bit concerne.
 subi.w	#$1,nb_bits	; Decrementation du nombre de bits.
 rts

;***********
Section DATA
;***********
file_name:
 dc.b		'a:1.img'
packedfile_name:
 dc.b		'a:1.pak'

;**********
Section BSS
;**********
even
bk_occurences:		; Occurences des bytes et knots.
 ds.l		512		
knots:				; Upperword: byte ou knot fort.
 ds.l		256		; Lowerword: byte ou knot faible.
bk_min:			; Index du byte ou knot de plus
 ds.w		1		; faible occurence.
bk_max:			; Index du byte ou knot de plus
 ds.w		1		; forte occurence.
knot_index:			; Knot courant.
 ds.w		1
nb_bits:			; Nb bits du codage courant.
 ds.w		1
byte_codage:			; Codage courant.
 ds.w		8
bytes_codages:		; Codage de chaque byte sur 9 mots
 ds.w		2304		; 1er mot: nb de bits du codage
 				; 8 mots suivants: codage du byte.
fin_section_bss:		; Aide pour initialisation de Section BSS.
 ds.w		1
megabuffer:			; Megabuffer,qui contient les donnees.
 ds.l		1		
