;**************************************************************************
; Routine for memory liberation:
mem_free:
; First, calculate the size of memory we need.
; Adress of the Base page is in 8(sp), cos we have already a jsr!
  move.l	8(sp),a0	; Adress of the Base page.
  move.l	$c(a0),d0	; Length of Text section.
  add.l	$14(a0),d0	; .. Data section.
  add.l	$1c(a0),d0	; .. Bss section.
  add.l	#$100,d0	; .. of the Base page.
  add.l	#$1000,d0	; An extra! ( Who knows!.. )

  move.l	d0,-(sp)	; Size of the memory we need.
  move.l	a0,-(sp)	; Adress where we need memory.
  clr.w	-(sp)	; ???
  move.w	#$4a,-(sp)	; "mshrink" function number.
  trap	#$1	; Call it.
  add.l	#$c,sp	; Reinit stack.
  rts
;**************************************************************************

;**************************************************************************
; Routine for aes initialisation.
aes_init:
  move.w	#$a,control	; Function "appl_init".
  move.w	#$0,control+2	; No parameters in int_in.
  move.w	#$0,control+6	; No parameters in addr_in.
.aes_call:		; Initialisations for this function are ok,
  movem.l	d0-a6,-(sp)	; We don' t know what aes use, so...
  move.l	#aes_parameters,d1  ; now call the aes.
  move.w	#$c8,d0	; For aes.
  trap	#$2
  movem.l	(sp)+,d0-a6
  rts		; aes_init over.
;**************************************************************************

;**************************************************************************
; Routine for aes exit.
aes_exit:		; When we do not need the aes more.
  move.w	#$13,control	; Function "appl_exit".
  move.w	#$0,control+2	; No parameters in int_in.
  move.w	#$0,control+6	; No parameters in addr_in.
.aes_call:		; Initialisations for this function are ok,
  movem.l	d0-a6,-(sp)	; We don' t know what aes use, so...
  move.l	#aes_parameters,d1  ; now call the aes.
  move.w	#$c8,d0	; For aes.
  trap	#$2
  movem.l	(sp)+,d0-a6
  rts		; aes_init over.
;**************************************************************************

;**************************************************************************
; Routine which creates a fileselector, and returns the path+name
; of the selected file in the space pointed by a0.
; Returns -1 in a0 if no file was selected!
	
aes_fileselect:
  move.w	#$5a,control	; Function "fsel_input".
  move.w	#$0,control+2	; No parameters in int_in.
  move.w	#$2,control+6	; Two parameters in addr_in.
  move.l	#fsel_path,addr_in  ; adress for "?.?" + path storage.
  move.l	#fsel_fname,addr_in+4  ; adress for fname storage.
.aes_call:		; Initialisations for this function are ok,
  movem.l	d0-a6,-(sp)	; We don' t know what aes use, so...
  move.l	#aes_parameters,d1  ; now call the aes.
  move.w	#$c8,d0	; For aes.
  trap	#$2
  movem.l	(sp)+,d0-a6
  cmpi.b	#$0,fsel_fname	; If fsel_fname is null, nothing was selected.
  beq.s	.fname_null

.concatenate:		; Something was selected, so we must
  movem.l	d0/a0-a2,-(sp)	; concatenate the path+fname.
  move.l	#fsel_path,a1
.search_path_end:	; Search the end of the path expression.
  cmp.b	#$0,(a1)	; The null byte marks the end.
  beq.s	.path_end_found
  addq.l	#$1,a1	; Next byte.
  bra.s	.search_path_end
.path_end_found:	; a1 points on the null byte.

.flush_inpath:		; Flush the "*.*" thingie or else.
  cmp.b	#'\',(a1)	; Search the "\" character.
  beq.s	.inpath_flushed
  subq.l	#$1,a1
  bra.s	.flush_inpath
.inpath_flushed:
  addq.l	#$1,a1	; Do not flush the "\".

  move.l	#fsel_path,a2
.copy_path:		; Copy the path byte per byte.
  move.b	(a2)+,(a0)+
  cmp.l	a2,a1	; Does a2 points on the last byte?
  bne.s	.copy_path	; No, then continue to copy.

  move.w	#$b,d0	; The fname does have less than 12
  move.l	#fsel_fname,a1	; characters.
.copy_fname:
  move.b	(a1)+,(a0)+	; Copy one byte.
  dbra	d0,.copy_fname

  move.b	#$0,(a0)+	; Put the null character.

  move.w	#$b,d0	; Flush the fname so that we can use
  move.l	#fsel_fname,a1	; the routine again.
.flush_fname:
  move.b	#$0,(a1)+	; Clear one byte.
  dbra	d0,.flush_fname

  movem.l	(sp)+,d0/a0-a2	; Concatenation over.
  rts

.fname_null:		; If nothing was selected, put -1 in a0.
  move.l	#-$1,a0
  rts	
;**************************************************************************

;**************************************************************************
; Routine which makes a box selector.
; a0 points on a '[0][Ligne1|Ligne2|..|Ligne5][Bouton1|Bouton2|Bouton3]'
; lookalike array.
; At the end of the function, a0 will contain the button selected.

aes_box:
  move.w	#$34,control	; Function "form_alert".
  move.w	#$1,control+2	; One parameter in int_in.
  move.w	#$1,control+4	; One parameter in int_out.
  move.w	#$1,control+6	; One parameter in addr_in.
  move.w	#$0,int_in	; No button will have the Default status.
  move.l	a0,addr_in	; Adress of the box definition.
.aes_call:
  movem.l	d0-a6,-(sp)	; We don' t know what aes use, so...
  move.l	#aes_parameters,d1  ; now call the aes.
  move.w	#$c8,d0	; For aes.
  trap	#$2
  movem.l	(sp)+,d0-a6
  move.w	int_out,a0	; Return the nb of the selected button.
  rts
;**************************************************************************

 even
text:
  dc.b	'null',0

;**************************************************************************
; The path and fname arrays for the aes_fileselect routines.
fsel_path:
  dc.b	"\*.*",0
  ds.b	128
fsel_fname:
  ds.b	128
;**************************************************************************

;**************************************************************************
; Parameters and arrays for the aes.

 even
aes_parameters:
  dc.l	control	; Points on the "control" array.
  dc.l	global	; .. on "global" array.
  dc.l	int_in	; Understood??...
  dc.l	int_out
  dc.l	addr_in
  dc.l	addr_out

control:		; Control array has a size of 5 words.
  ds.w	5
global:		; Global array .. 16 words.
  ds.w	16
int_in:
  ds.w	16
int_out:
  ds.w	7
addr_in:
  ds.l	2
addr_out:
  ds.l	1
