; *************************************************************************
; *****                                                               *****
; *****              Programm which displays iff pictures.            *****
; *****                                                               *****
; *************************************************************************

  jsr	mem_free	; Don' t need all the memory.
  jsr	aes_init	; Initialise aes.

welcome_message:	; Display a welcome message.
  move.l	#welcome,a0
  jsr	aes_box	; Aes function for an alert box.
  move.w	a0,d0

chose_iff_file:		; Let the user chose the iff file
  move.l	#iff_filename,a0 ; with a fileselect box.
  jsr	aes_fileselect
  cmp.l	#-1,a0	; "Cancel" was pushed?
  beq	exit	; Then quit the proggy.

; **  Note that calling the aes fileselect in supervisor mode makes
; **  the gem crash,(??) so i switch to supervisor only now.
supervisor:		; User mode is crap....
  move.l	#$0,-(sp)
  move.w	#$20,-(sp)
  trap	#$1
  addq.l	#$6,sp

set_dta:		; Set the disk transfer area.
  move.l	#dta_buffer,-(sp)
  move.w	#$1a,-(sp)
  trap	#$1
  addq.l	#$6,sp

search_file_length:
  move.w	#$0,-(sp)	; Normal file.
  move.l	#iff_filename,-(sp) ; Name of the file.
  move.w	#$4e,-(sp)
  trap	#$1
  addq.l	#$8,sp
  move.l	dta_buffer+26,file_length ; We got it.

load_iff_file:
  move.w	#$0,-(sp)	; Write mode.
  move.l	#iff_filename,-(sp)
  move.w	#$3d,-(sp)	; Fopen.
  trap	#$1
  addq.l	#$8,sp
  move.w	d0,d7	; Handle number.
  move.l	#iff_image,-(sp) ; Load in this buffer.
  move.l	file_length,-(sp)
  move.w	d7,-(sp)
  move.w	#$3f,-(sp)	; Fread.
  trap	#$1
  add.l	#12,sp
  move.w	d7,-(sp)
  move.w	#$3e,-(sp)	; Fclose.
  trap	#$1
  addq.l	#$4,sp

search_cmap:		; Search and store the colormap.
  move.l	#iff_image,a0
.search:
  addq.l	#$2,a0
  cmp.l	#'CMAP',(a0)
  bne.s	.search
  addq.l	#$4,a0
  move.l	(a0)+,d0	; Length of colormap.
  subq.l	#$1,d0	; Beware the dbra.
  move.l	#color_map,a1
.copy:
  move.b	(a0)+,(a1)+
  dbra	d0,.copy

search_bmhd:		; Search usefull infos in the header.
  move.l	#iff_image,a0
.search:
  addq.l	#$2,a0
  cmp.l	#'BMHD',(a0)
  bne.s	.search
  move.w	8(a0),size_x
  move.w	10(a0),size_y
  move.b	16(a0),nb_bitplanes
  cmp.b	#$0,18(a0)
  beq	unpacked

packed:		; The file is packed, so depack while
  move.l	#iff_image,a0	; copying the body in the buffer.
.search:
  addq.l	#$2,a0
  cmp.l	#'BODY',(a0)
  bne.s	.search
  addq.l	#$8,a0	; a0 points on the datas.
;  move.l	#$f8000,a1
  move.l	#buffer,a1	; a1 points on the area where to depack.

  move.w	size_y,d7	; Nb of lines to depack.
.one_line:
  move.b	nb_bitplanes,d6	; Nb of bitplanes to depack.
.one_bitplane:
  move.w	size_x,d5	; Width of the image.
  lsr.w	#$3,d5	; Nb of bytes per bitplane.
.one_byte:
  move.b	(a0)+,d4	; This byte is a control byte.
  tst.b	d4	; Is it negative?
  bmi.s	.repeted
  and.l	#$7f,d4	; It's positive, so copy the d4+1 next
.copy_litteraly:	; bytes litteraly.
  move.b	(a0)+,(a1)+
  sub.w	#1,d5	; One byte less.
  beq.s	.next_bitplane	; All the bytes for this bpl are over?
  dbra	d4,.copy_litteraly ; The litteral copy is over?
  bra.s	.one_byte	; Yes, then next control byte.

.repeted:		; Copy the next byte -d4+1 time.
  move.b	(a0)+,d3	; d3=byte to be copied.
  neg.b	d4	; d4=-n.
  and.l	#$7f,d4	; Fuck the uninteresting bits.
.copy:
  move.b	d3,(a1)+	; Copy the byte once.
  sub.w	#1,d5	; One byte less.
  beq.s	.next_bitplane	; All the bytes for this bpl are over?
  dbra	d4,.copy	; The repetition is over?
  bra.s	.one_byte	; Yes, then next control byte.

.next_bitplane:
  sub.b	#$1,d6	; One bitplane less.
  bne.s	.one_bitplane	

.next_line:		; One line less.
  sub.w	#$1,d7
  bne.s	.one_line

  bra.s	planar_2_grayscale ; Enough of those fucking bitplanes.


unpacked:		; The body is not packed, then copy it.
  move.l	#iff_image,a0	; copying the body in the buffer.
.search:
  addq.l	#$2,a0
  cmp.l	#'BODY',(a0)
  bne.s	.search
  addq.l	#$8,a0	; a0 points on the datas.
;  move.l	#$f8000,a1
  move.l	#buffer,a1
  move.w	size_y,d7	; Calculate the size of the body.
  move.w	size_x,d6
  lsr.w	#$3,d6
  mulu.w	d6,d7
  moveq.l	#$0,d6
  move.b	nb_bitplanes,d6
  mulu.w	d6,d7	; d7=size_y*(size_x/8)*nb_bitplanes.
.copy:
  move.b	(a0)+,(a1)+
  subq.l	#$1,d7
  bne.s	.copy


;**************************************************************************
; Change from planar RGB mode to a 48 grayscale mode.
planar_2_grayscale:	; First convert the colormap to grayscale.
  move.l	#color_map,a0
  move.l	#grays,a1
  move.b	nb_bitplanes,d1
  and.l	#$ff,d1
  moveq.l	#$1,d0
  lsl.w	d1,d0	; Nb of colors=2^nb_bitplanes.
  subq.w	#$1,d0
.one_color:
  move.b	(a0)+,d1	; Load the three compounds.
  move.b	(a0)+,d2
  move.b	(a0)+,d3
  lsr.b	#$4,d1	; Care only about the 4 MSBits.
  lsr.b	#$4,d2
  lsr.b	#$4,d3
  add.b	d1,d2
  add.b	d2,d3	; d3=R+G+B.
  move.b	d3,(a1)+	; Store this gray value.
  dbra	d0,.one_color

.convert:
  move.l	#buffer,a0
  move.l	#iff_image,a1
  move.l	#grays,a2

  move.w	size_y,d0
  subq.w	#$1,d0	; Beware the dbra.
  move.w	size_x,d1
  lsr.w	#$3,d1	; Go by group of 8 pixels.
  move.w	d1,d6	; d6=offset between 2 bpls.
  subq.w	#$1,d1	; Fucking dbra.
  moveq.l	#$0,d2
  move.b	nb_bitplanes,d2
  subq.w	#$1,d2	; Fucking dbra again and again.
  move.w	d6,d7
  mulu.w	d2,d7
  move.l	d7,a4	; a4=Offset between two lines.
  move.l	d2,a3
;  subq.w	#$1,a3	; Fucking dbra again and again.
  moveq.l	#$0,d5	; This will contain the values.

  move.l	a4,a5
;  sub.w	d6,a5

.one_line:
  move.w	d1,d2
.one_block:		; Go for it by 8 pixels block.

  move.l	a3,d3	; The nb of bpls -1.
  move.l	a5,d4	; For the offset on the bitplanes.
  moveq.l	#$0,d5	; This will contain the values.
.one_bit_1:
  move.b	(a0,d4.w),d7
  add.b	d7,(a0,d4.w)	; The right bit is put in the carry.
  addx.b	d5,d5	; d5 is shifted right, the carry is added.
  sub.w	d6,d4	; Next bitplane.
  dbra	d3,.one_bit_1
  move.b	(a2,d5.w),(a1)+	; Store the value.

  move.l	a3,d3	; The nb of bpls -1.
  move.l	a5,d4	; For the offset on the bitplanes.
  moveq.l	#$0,d5	; This will contain the values.
.one_bit_2:
  move.b	(a0,d4.w),d7
  add.b	d7,(a0,d4.w)	; The right bit is put in the carry.
  addx.b	d5,d5	; d5 is shifted right, the carry is added.
  sub.w	d6,d4	; Next bitplane.
  dbra	d3,.one_bit_2
  move.b	(a2,d5.w),(a1)+	; Store the value.

  move.l	a3,d3	; The nb of bpls -1.
  move.l	a5,d4	; For the offset on the bitplanes.
  moveq.l	#$0,d5	; This will contain the values.
.one_bit_3:
  move.b	(a0,d4.w),d7
  add.b	d7,(a0,d4.w)	; The right bit is put in the carry.
  addx.b	d5,d5	; d5 is shifted right, the carry is added.
  sub.w	d6,d4	; Next bitplane.
  dbra	d3,.one_bit_3
  move.b	(a2,d5.w),(a1)+	; Store the value.

  move.l	a3,d3	; The nb of bpls -1.
  move.l	a5,d4	; For the offset on the bitplanes.
  moveq.l	#$0,d5	; This will contain the values.
.one_bit_4:
  move.b	(a0,d4.w),d7
  add.b	d7,(a0,d4.w)	; The right bit is put in the carry.
  addx.b	d5,d5	; d5 is shifted right, the carry is added.
  sub.w	d6,d4	; Next bitplane.
  dbra	d3,.one_bit_4
  move.b	(a2,d5.w),(a1)+	; Store the value.

  move.l	a3,d3	; The nb of bpls -1.
  move.l	a5,d4	; For the offset on the bitplanes.
  moveq.l	#$0,d5	; This will contain the values.
.one_bit_5:
  move.b	(a0,d4.w),d7
  add.b	d7,(a0,d4.w)	; The right bit is put in the carry.
  addx.b	d5,d5	; d5 is shifted right, the carry is added.
  sub.w	d6,d4	; Next bitplane.
  dbra	d3,.one_bit_5
  move.b	(a2,d5.w),(a1)+	; Store the value.

  move.l	a3,d3	; The nb of bpls -1.
  move.l	a5,d4	; For the offset on the bitplanes.
  moveq.l	#$0,d5	; This will contain the values.
.one_bit_6:
  move.b	(a0,d4.w),d7
  add.b	d7,(a0,d4.w)	; The right bit is put in the carry.
  addx.b	d5,d5	; d5 is shifted right, the carry is added.
  sub.w	d6,d4	; Next bitplane.
  dbra	d3,.one_bit_6
  move.b	(a2,d5.w),(a1)+	; Store the value.

  move.l	a3,d3	; The nb of bpls -1.
  move.l	a5,d4	; For the offset on the bitplanes.
  moveq.l	#$0,d5	; This will contain the values.
.one_bit_7:
  move.b	(a0,d4.w),d7
  add.b	d7,(a0,d4.w)	; The right bit is put in the carry.
  addx.b	d5,d5	; d5 is shifted right, the carry is added.
  sub.w	d6,d4	; Next bitplane.
  dbra	d3,.one_bit_7
  move.b	(a2,d5.w),(a1)+	; Store the value.

  move.l	a3,d3	; The nb of bpls -1.
  move.l	a5,d4	; For the offset on the bitplanes.
  moveq.l	#$0,d5	; This will contain the values.
.one_bit_8:
  move.b	(a0,d4.w),d7
  add.b	d7,(a0,d4.w)	; The right bit is put in the carry.
  addx.b	d5,d5	; d5 is shifted right, the carry is added.
  sub.w	d6,d4	; Next bitplane.
  dbra	d3,.one_bit_8
  move.b	(a2,d5.w),(a1)+	; Store the value.

  addq.l	#$1,a0	; Next byte.
  dbra	d2,.one_block

  add.l	a4,a0	; Next line.
  dbra	d0,.one_line



;**************************************************************************
linear_2_grays:		; Ok, now go to 16 grays mode.
  move.l	#iff_image,a0
  move.l	#buffer,a1
  move.l	#$f8000,a2

  move.w	size_y,d0	; Nb of lines.
  subq.w	#$1,d0	
.one_line:
  move.w	size_x,d1
  lsr.w	#$4,d1	; We work with group of 16 pixies.
  subq.w	#$1,d1
.one_group:
  moveq.l	#$0,d2	; d2-d5 for four bitplanes.
  moveq.l	#$0,d3
  moveq.l	#$0,d4
  moveq.l	#$0,d5
 rept	16	; 16 pixels.
  moveq.l	#$0,d6
  move.b	(a0)+,d6	; d6=the gray value, between 0-47.
  divs.w	#$3,d6	; report it between 0-15.
  lsl.l	#4,d6	; Put it on the left.
  add.b	d6,d6	; First bit.
  addx.w	d2,d2
  add.b	d6,d6	; Second bit.
  addx.w	d3,d3
  add.b	d6,d6	; Third bit.
  addx.w	d4,d4
  add.b	d6,d6	; Fourth bit.
  addx.w	d5,d5
 endr
  move.w	d5,(a1)+
  move.w	d4,(a1)+
  move.w	d3,(a1)+
  move.w	d2,(a1)+
  dbra	d1,.one_group
  dbra	d0,.one_line

show_image:
  dc.w	$a00a	; Hide mouse.
  move.w	#$8240,a0	; Store gem colors and put grays.
  move.l	#gem_colors,a1
  move.l	#colors,a2
 rept	8
  move.l	(a0),(a1)+
  move.l	(a2)+,(a0)+
 endr

  move.b	$ffff8201.w,old_screen
  move.b	$ffff8203.w,old_screen+1
  move.l	#buffer,screen_adress

  move.w	$ffff8260.w,old_res

  move.w	#$25,-(sp)	; Vsync.
  trap	#$1
  addq.l	#$2,sp
  move.b	#$0,$ffff8260.w

.one_vbl:
  move.w	#$25,-(sp)	; Vsync.
  trap	#$1
  addq.l	#$2,sp

  move.w	size_x,d0
  sub.w	#320,d0
  lsr.w	#$2,d0


  move.b	d0,$ffff820f.w

  move.b	screen_adress+1,$ffff8201.w
  move.b	screen_adress+2,$ffff8203.w
  move.b	screen_adress+3,$ffff820d.w

  move.b	$fffffc02.w,d0	; The key pressed. ( If any.)
  cmpi.b	#$39,d0
  beq.s	.gem	; space then quit.

  move.w	size_x,d1
  ext.w	d1
  lsr.w	#$1,d1

  cmpi.b	#$4b,d0	; Cursor left?
  bne.s	.not_left
.left:
  sub.l	#$8,screen_adress
  bra.s	.not_down
.not_left:
  cmpi.b	#$4d,d0	; Cursor right?
  bne.s	.not_right
.right:
  add.l	#$8,screen_adress
  bra.s	.not_down
.not_right:
  cmpi.b	#$48,d0	; Cursor up?
  bne.s	.not_up
.up:
  sub.l	d1,screen_adress
  bra.s	.not_down
.not_up:
  cmpi.b	#$50,d0	; Cursor down?
  bne.s	.not_down
.down:
  add.l	d1,screen_adress
.not_down:

  bra	.one_vbl


.gem:		; Back to gem.
  dc.w	$a009	; Show mouse.
  move.w	#$8240,a0	; Restore gem colors.
  move.l	#gem_colors,a1
 rept	8
  move.l	(a1)+,(a0)+
 endr

  move.w	#$25,-(sp)	; Vsync.
  trap	#$1
  addq.l	#$2,sp

  move.b	#0,$ffff820f.w
  move.b	old_screen,$ffff8201.w
  move.b	old_screen+1,$ffff8203.w
  move.b	#$0,$ffff820d
  move.w	old_res,$ffff8260.w

user:		; User mode is crap, but in supervisor
  move.l	#$0,-(sp)	; mode the aes crashes.
  move.w	#$20,-(sp)
  trap	#$1
  addq.l	#$6,sp

  bra	chose_iff_file

exit:
  jsr	aes_exit	; Close aes.
  clr.w	-(sp)	; And quit.
  trap	#$1


;**************************************************************************
; All the gem (shitty) routines.

  include	'a:\iff\gem_shit.s'

;**************************************************************************
  Section DATA

welcome:
  dc.b	'[1][ | IFF Viewer 1.0 | |By Alain Brobecker.][Welcome]',0
 even
colors:
;N set 0
; rept 16
;  dc.w	N
;N set N+$111
; endr

  dc.w	$000,$888,$111,$999,$222,$aaa,$333,$bbb
  dc.w	$444,$ccc,$555,$ddd,$666,$eee,$777,$fff

;**************************************************************************
  Section BSS

  even
iff_filename:
  ds.b	128
dta_buffer:		; Disk transfer area.
  ds.b	44
file_length:
  ds.l	1

size_x:
  ds.w	1
size_y:
  ds.w	1
nb_bitplanes:
  ds.w	1
color_map:		; Max 256 colors with R,G,B.
  ds.b	256*3
grays:		; Gray values for each color.
  ds.b	256
screen_adress:
  ds.l	1
gem_colors:
  ds.w	16
old_res:
  ds.w	1
old_screen:
  ds.l	1

iff_image:
  ds.b	150000
buffer:
  ds.b	150000
