; ********************************************
; **  1ST test for a sprite-code-generator. **
; **    Dracula/Positivity      26.12.93    **
; ********************************************
; Sprite must have a width inferior to 16, and must be in 2 bpls.
; Note: up(dx) means "upperword of dx".
; The code is generated taking in mind that when you call a rout, a0
;   contains the adress of the first word where to print the sprite.

 opt	o+

line_size	equ  $a0-$10	; In case of wider screens.
planes	equ  $8	; More bitplanes?

;*****************************************************************************
; First, the code generation!

generation:
  move.l	#routines,a0	; We will generate the routs in here.
  move.l	#routs_adresses,a1 ; To store the adresses.

  moveq.w	#$0,d7	; Counter for the number of routs.
generate_one_rout:	; Show is going on.
  move.l	a0,(a1)+	; Save the adress of the current rout.
  move.l	#sprite,a2
  move.l	#sprite_mask,a3
  moveq.l	#$0,d5	; d5 is the displacement.

  move.w	lines_nb,d6	; Number of lines for the sprite.
generate_one_line:
  moveq.l	#$0,d0	; Prepare registers.
  moveq.l	#$0,d1
  moveq.l	#-$1,d2
  move.w	(a2)+,d0	; d0=data for bpl0.
  ror.l	d7,d0	; Rotate the sprite.
  move.w	(a2)+,d1	; d1=data for bpl1.
  ror.l	d7,d1	; Rotate the sprite.
  move.w	(a3)+,d2	; d2=sprite for the mask.
  ror.l	d7,d2	; Rotate the mask.
  move.l	d2,d3
  not.l	d3	; d3=not mask.(Already rotated.)

; Ok, now we will generate code for the upperwords of the sprite,
; and then we will work with the lowerword.
upperword_case:
  tst.w	d3
  beq.s	case_up_0
  cmp.w	d0,d3
  bne.s	.d0_not_d3
  cmp.w	d1,d3
  beq.s	case_up_1
  tst.w	d1
  beq.s	case_up_2
  bra.s	case_up_3
.d0_not_d3:
  cmp.w	d1,d3
  bne.s	.d1_not_d3_too
  tst.w	d0
  beq.s	case_up_4
  bra.s	case_up_5
.d1_not_d3_too:
  tst.w	d0
  bne.s	.d0_not_null
  tst.w	d1
  beq	case_up_6
  bra	case_up_7
.d0_not_null:
  tst.w	d1
  beq	case_up_8
.d1_not_null_too:
  bra	case_up_9

case_up_0:	; ** up(d3)=0, nothing in this part of the sprite.
  addq.l	#planes,d5	; Reactualise the displacement.
  bra	lowerword_case

case_up_1:	; ** up(d0)=up(d1)=up(d3).
  move.w	#$00a8,(a0)+	; Only make a "ori.l" with d0+d1.
  move.w	d0,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra	lowerword_case

case_up_2:	; ** up(d0)=up(d3) and up(d1)=0.
  move.w	#$0068,(a0)+	; Make a "ori.w" with d0 on disp, and
  move.w	d0,(a0)+	; a "andi.w" with d2 on disp+2.
  move.w	d5,(a0)+
  addq.w	#$2,d5	; Next bitplane.
  move.w	#$0268,(a0)+
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes-2,d5	; Reactualise the displacement.
  bra	lowerword_case

case_up_3:	; ** up(d0)=up(d3) & up(d1)#0 & up(d1)#up(d3).
  move.w	#$0268,(a0)+	; Make a "andi.w" with d2 on disp+2,
  move.w	d2,(a0)+	; and a "ori.l" with d0+d1 on disp.
  move.w	d5,(a0)
  addi.w	#$2,(a0)+
  move.w	#$00a8,(a0)+
  move.w	d0,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra	lowerword_case

case_up_4:	; ** up(d1)=up(d3) & up(d0)=0.
  move.w	#$0268,(a0)+	; Make a "andi.w" with d2 on disp,
  move.w	d2,(a0)+	; and a "ori.w" with d1 on disp+2.
  move.w	d5,(a0)+
  addq.w	#$2,d5	; Next bitplane.
  move.w	#$0068,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes-2,d5	; Reactualise the displacement.
  bra.s	lowerword_case

case_up_5:	; ** up(d1)=up(d3) & up(d0)#0 & up(d0)#up(d3).
  move.w	#$0268,(a0)+	; Make a "andi.w" with d2 on disp,
  move.w	d2,(a0)+	; and a "ori.l" with d0+d1 on disp.
  move.w	d5,(a0)+
  move.w	#$00a8,(a0)+
  move.w	d0,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra.s	lowerword_case

case_up_6:	; ** up(d0)=0 & up(d1)=0.
  move.w	#$02a8,(a0)+	; Make a "andi.l" with d2+d2 on disp.
  move.w	d2,(a0)+
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra.s	lowerword_case

case_up_7:	; ** up(d0)=0 & up(d1)#0 & up(d1)#up(d3).
  move.w	#$02a8,(a0)+	; Make a "andi.l" with d2+d2 on disp,
  move.w	d2,(a0)+	; and a "ori.w" with d1 on disp+2.
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  addq.w	#$2,d5	; Next bitplane.
  move.w	#$0068,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes-2,d5	; Reactualise the displacement.
  bra.s	lowerword_case

case_up_8:	; ** up(d1)=0 & up(d0)#0 & up(d0)#up(d3).
  move.w	#$02a8,(a0)+	; Make a "andi.l" with d2+d2 on disp,
  move.w	d2,(a0)+	; and a "ori.w" with d0 on disp.
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  move.w	#$0068,(a0)+
  move.w	d0,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra.s	lowerword_case

case_up_9:	; ** up(d0)#0 & up(d1)#0 & up(d0)#up(d3) & up(d1)#up(d3).
  move.w	#$02a8,(a0)+	; Make a "andi.l" with d2+d2 on disp,
  move.w	d2,(a0)+	; and a "ori.l" with d0+d1 on disp.
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  move.w	#$00a8,(a0)+
  move.w	d0,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.



lowerword_case:		; We are now intersted in the second part
  swap.w	d0	; of the sprites.
  swap.w	d1
  swap.w	d2
  swap.w	d3

  tst.w	d3
  beq.s	case_low_0
  cmp.w	d0,d3
  bne.s	.d0_not_d3
  cmp.w	d1,d3
  beq.s	case_low_1
  tst.w	d1
  beq.s	case_low_2
  bra.s	case_low_3
.d0_not_d3:
  cmp.w	d1,d3
  bne.s	.d1_not_d3_too
  tst.w	d0
  beq.s	case_low_4
  bra.s	case_low_5
.d1_not_d3_too:
  tst.w	d0
  bne.s	.d0_not_null
  tst.w	d1
  beq	case_low_6
  bra	case_low_7
.d0_not_null:
  tst.w	d1
  beq	case_low_8
.d1_not_null_too:
  bra	case_low_9


case_low_0:	; ** up(d3)=0, nothing in this part of the sprite.
  addq.l	#planes,d5	; Reactualise the displacement.
  bra	line_generated

case_low_1:	; ** up(d0)=up(d1)=up(d3).
  move.w	#$00a8,(a0)+	; Only make a "ori.l" with d0+d1.
  move.w	d0,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra	line_generated

case_low_2:	; ** up(d0)=up(d3) and up(d1)=0.
  move.w	#$0068,(a0)+	; Make a "ori.w" with d0 on disp, and
  move.w	d0,(a0)+	; a "andi.w" with d2 on disp+2.
  move.w	d5,(a0)+
  addq.w	#$2,d5	; Next bitplane.
  move.w	#$0268,(a0)+
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes-2,d5	; Reactualise the displacement.
  bra	line_generated

case_low_3:	; ** up(d0)=up(d3) & up(d1)#0 & up(d1)#up(d3).
  move.w	#$0268,(a0)+	; Make a "andi.w" with d2 on disp+2,
  move.w	d2,(a0)+	; and a "ori.l" with d0+d1 on disp.
  move.w	d5,(a0)
  addi.w	#$2,(a0)+
  move.w	#$00a8,(a0)+
  move.w	d0,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra	line_generated

case_low_4:	; ** up(d1)=up(d3) & up(d0)=0.
  move.w	#$0268,(a0)+	; Make a "andi.w" with d2 on disp,
  move.w	d2,(a0)+	; and a "ori.w" with d1 on disp+2.
  move.w	d5,(a0)+
  addq.w	#$2,d5	; Next bitplane.
  move.w	#$0068,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes-2,d5	; Reactualise the displacement.
  bra.s	line_generated

case_low_5:	; ** up(d1)=up(d3) & up(d0)#0 & up(d0)#up(d3).
  move.w	#$0268,(a0)+	; Make a "andi.w" with d2 on disp,
  move.w	d2,(a0)+	; and a "ori.l" with d0+d1 on disp.
  move.w	d5,(a0)+
  move.w	#$00a8,(a0)+
  move.w	d0,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra.s	line_generated

case_low_6:	; ** up(d0)=0 & up(d1)=0.
  move.w	#$02a8,(a0)+	; Make a "andi.l" with d2+d2 on disp.
  move.w	d2,(a0)+
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra.s	line_generated

case_low_7:	; ** up(d0)=0 & up(d1)#0 & up(d1)#up(d3).
  move.w	#$02a8,(a0)+	; Make a "andi.l" with d2+d2 on disp,
  move.w	d2,(a0)+	; and a "ori.w" with d1 on disp+2.
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  addq.w	#$2,d5	; Next bitplane.
  move.w	#$0068,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes-2,d5	; Reactualise the displacement.
  bra.s	line_generated

case_low_8:	; ** up(d1)=0 & up(d0)#0 & up(d0)#up(d3).
  move.w	#$02a8,(a0)+	; Make a "andi.l" with d2+d2 on disp,
  move.w	d2,(a0)+	; and a "ori.w" with d0 on disp.
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  move.w	#$0068,(a0)+
  move.w	d0,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.
  bra.s	line_generated

case_low_9:	; ** up(d0)#0 & up(d1)#0 & up(d0)#up(d3) & up(d1)#up(d3).
  move.w	#$02a8,(a0)+	; Make a "andi.l" with d2+d2 on disp,
  move.w	d2,(a0)+	; and a "ori.l" with d0+d1 on disp.
  move.w	d2,(a0)+
  move.w	d5,(a0)+
  move.w	#$00a8,(a0)+
  move.w	d0,(a0)+
  move.w	d1,(a0)+
  move.w	d5,(a0)+
  addq.l	#planes,d5	; Reactualise the displacement.

line_generated:		; Ok, it's finished for this line.
  add.l	#line_size,d5	; Displacement for the next line.
  dbra	d6,generate_one_line

rout_generated:		; The routine is generated, except that
  move.l	#end_of_routs,a2 ; we have to generate the ending of
  move.w	end_length,d6	; the routine.
.copy_one:
  move.w	(a2)+,(a0)+
  subq.w	#$2,d6
  bne.w	.copy_one

  addq.w	#$1,d7	; Counter for the routines generated.
  cmp.w	#$10,d7	; All 16 routs generated?
  bne	generate_one_rout


;*****************************************************************************
; Well, maybe testing the routines is a good idea!

supervisor:
  move.l	#$0,-(sp)
  move.w	#$20,-(sp)
  trap	#$1
  addq.l	#$6,sp

  move.w	#$25,-(sp)
  trap	#$e	; Vertical sync.
  addq.l	#$2,sp
  move.b	#$0,$ffff8260.w	; Low res.

one_vbl:
  move.w	#$25,-(sp)
  trap	#$e	; Vertical sync.
  addq.l	#$2,sp

  move.w	#$000,$ffff8240.w

  move.w	#37,d7	; (d7+1)*16 sprites.
.one_set:		; Print a set of 16 sprites.
  move.l	#routs_adresses,a1
  move.l	#$f8000,a0
  rept	16
  move.l	(a1)+,a2
  jsr	(a2)
  addq.l	#$8,a0	; Separate the sprites.
  endr
  dbra	d7,.one_set

  move.w	#$557,$ffff8240.w

  cmpi.b	#$39,$fffffc02.w
  bne	one_vbl

  move.w	#$25,-(sp)
  trap	#$e	; Vertical sync.
  addq.l	#$2,sp
  move.b	#$1,$ffff8260.w	; Mid res.

end_of_proggy:
  clr.w	-(sp)
  trap	#$1	; Program term.



end_of_routs:		; Here is the bit of code to put
  rts		; after each generated rout. ( In this
  		; case a mere rts.)
end_of_blurg:		; To know the length of this bit of code.

;*****************************************************************************
  Section DATA

end_length:		; The length of the final bit of rout.
  dc.w	end_of_blurg-end_of_routs

lines_nb:		; Heigth of the sprite-1.
  dc.w	2
sprite:
  dc.w	%1010000000000000,%0100000000000000
  dc.w	%0100000000000000,%1110000000000000
  dc.w	%1010000000000000,%0100000000000000
sprite_mask:
  dc.w	%0001111111111111
  dc.w	%0001111111111111
  dc.w	%0001111111111111

;*****************************************************************************
  Section BSS

routs_adresses:		; To store the adresses of the
  ds.l	16	; generated routines.

routines:		; Space to create the routines.
  ds.l	4000
