 move.l	#$fff,a4
repeat:

 move.w	#$40,d0
 move.w	#$40,d1
 move.w	#$20,d2
 move.w	#$60,d3
 move.l	#xmins,a1
 move.l	#$f8000,a0
 jsr	xmin
 move.w	#$20,d0
 move.w	#$60,d1
 move.w	#$40,d2
 move.w	#$80,d3
 move.l	#$f8000,a0
 jsr	xmin

 moveq.l	#$0,d7

 move.w	#$40,d0
 move.w	#$40,d1
 move.w	#$60,d2
 move.w	#$60,d3
 move.l	#xmaxs,a1
 move.l	#$f8000,a0
 jsr	xmax
 move.w	#$60,d0
 move.w	#$60,d1
 move.w	#$40,d2
 move.w	#$80,d3
 move.l	#$f8000,a0
 jsr	xmax

 move.l	#xmins,a0
 move.l	#xmaxs,a1
 move.l	#$f8000,d0
 move.w	#$ffff,d6
one_line:
 move.w	(a0)+,d0
 move.w	(a1)+,d1
 sub.w	d0,d1
 beq	melted
 lsr.w	#$3,d1
 subq.w	#$2,d1
 bmi	near
 move.l	d0,a6
 move.w	(a0)+,(a6)
 addq.l	#$8,a6
one_word:
 move.w	d6,(a6)
 addq.l	#$8,a6
 dbra	d1,one_word
 move.w	(a1)+,(a6)
 dbra	d7,one_line

end:
 subq.l	#$1,a4
 cmp.l	#$0,a4
 bne	repeat

 clr.w	-(sp)
 trap	#1




near:
 move.l	d0,a6
 move.w	(a0)+,(a6)
 addq.l	#$8,a6
 move.w	(a1)+,(a6)
 dbra	d7,one_line
 jmp	end

melted:
 move.w	(a0)+,d2
 move.w	(a1)+,d3
 and.w	d2,d3
 move.l	d0,a6
 move.w	d3,(a6)
 dbra	d7,one_line
 jmp	end


xmaxs:
 ds.l	$200

xmins:
 ds.l	$200


;*******************
; Calcul des Xmins.
;*******************
; Appel:
;   d0.w = x1.
;   d1.w = y1.
;   d2.w = x2.
;   d3.w = y2.
;   a0.l = adresse ramvideo.
;   a1.l = adresse sauvegarde.
; Sortie:
;   d7.w = d7.w + nbr_lignes -1.
;   (a1) = adresse.w + motif.w.

xmin:
 move.l	#min_word,a2
 sub.w	d0,d2	; d2=y2-y1.
 beq	xmin_ver	; Ligne verticale?
 bpl	xmin_bad	; x2>x1?


;**************************
; x1>x2 Traitement normal.
;**************************

xmin_ok:
 neg.w	d2	; d2=abs(x2-x1).
 sub.w	d1,d3	; d3=y2-y1, et dans ce cas d3>0.
 add.w	d3,d7	; d7=nbr de lignes.
 move.w	d1,d4	; On multiplie y1 par 160, mais
 lsl.w	#$2,d1	; en evitant les mulu pour avoir
 add.w	d4,d1	; l'adresse de debut de ligne.
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la bonne ligne.
 move.w	d0,d1	; On cherche a se placer sur le bon mot.
 andi.w	#$fff0,d0	; d0=x1-x1 mod(16).
 sub.w	d0,d1	; d1=x1 mod(16).
 lsr.w	#$1,d0	; On a 8 octets pour 16 pixels.
 add.w	d0,a0	; a0 pointe sur le bon mot.
 moveq.l	#$0,d0	; On a besoin du upperword du motif.
 add.w	d1,d1	; On met ensuite le motif de depart dans
 move.w	(a2,d1.w),d0	; d0, en sachant que 1 motif=1 mot.
 move.l	#$a0,d1	; d1=160, increment pour une ligne.
 cmp.w	d3,d2	; Pente faible ou forte?
 bmi	ok_big

;***********************
; dx>=dy, pente faible.

ok_low:
 move.w	d2,d5	; d5=dx=nbr de points.
 add.w	d3,d3	; d3=2*dy.
 move.w	d3,d4	; d4=Erreur.
 sub.w	d2,d4	; E=2*dy-dx.
 add.w	d2,d2	; d2=2*dx.
 subq.w	#$1,d5	; A cause du dbra.

ok_lowline:		; La routine de ligne pour ce cas.
 tst.w	d4	; Erreur positive?
 bgt.s	ok_low_epos	
ok_low_eneg:		; Erreur negative.
 add.w	d3,d4 	; E=E+2*dy.
 add.l	d0,d0	; Nouveau motif, un pixel plus a gauche.
 addq.w	#$1,d0	; Bit rentrant a 1.
 bmi.s	ok_low_xneg	; Motif completement rempli?
ok_low_plot:
 dbra	d5,ok_lowline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 rts

ok_low_epos:		; Erreur positive.
 sub.w	d2,d4	; E=E-2*dx.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 add.l	d1,a0	; Ligne suivante.
ok_low_eneg2:		; Prochain point sur x.
 add.w	d3,d4 	; E=E+2*dy.
 add.l	d0,d0	; Nouveau motif, un pixel plus a gauche.
 addq.w	#$1,d0	; Bit rentrant a 1.
 bmi.s	ok_low_xneg	; Motif completement rempli?
ok_low_plot2:
 dbra	d5,ok_lowline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 rts

ok_low_xneg:		; Changement de motif.
 btst.l	#$10,d0	; Le motif vient d'etre rempli?
 beq.s	ok_low_plot
 moveq.l	#$1,d0	; Non, ca deborde sur le upperword, on
 subq.l	#$8,a0	; change donc de motif et d'adresse.
ok_low_plot3:
 dbra	d5,ok_lowline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 rts

;*********************
; dx<dy, pente forte.

ok_big:		; Pente forte.
 move.w	d3,d5	; d5=dy=nbr de points.
 add.w	d2,d2	; d2=2*dx.
 move.w	d2,d4	; d4=Erreur.
 sub.w	d3,d4	; E=2*dx-dy.
 add.w	d3,d3	; d2=2*dy.
 subq.w	#$1,d5	; A cause du dbra.

ok_bigline:		; La routine de ligne pour ce cas.
 tst.w	d4	; Erreur positive?
 bgt.s	ok_big_epos	
ok_big_eneg:		; Erreur negative.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
ok_big_plot:
 dbra	d5,ok_bigline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 rts

ok_big_epos:		; Erreur positive.
 sub.w	d3,d4	; E=E-2*dy.
 add.l	d0,d0	; Nouveau motif, un pixel plus a gauche.
 addq.w	#$1,d0	; Bit rentrant a 1.
 bmi.s	ok_big_xneg	; Motif deborde sur le upperword?
ok_big_eneg2:		; Prochain point sur y.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
ok_big_plot2:
 dbra	d5,ok_bigline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 rts

ok_big_xneg:		; Changement de motif.
 btst.l	#$10,d0	; Le motif vient d'etre rempli?
 beq.s	ok_big_plot
 moveq.l	#$1,d0	; Non, ca deborde sur le upperword, on
 subq.l	#$8,a0	; change donc de motif et d'adresse.
ok_big_eneg3:		; Prochain point sur y.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
ok_big_plot3:
 dbra	d5,ok_bigline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 rts



;***************************
; x1<x2 Traitement inverse.
;***************************

xmin_bad:
 sub.w	d1,d3	; d3=y2-y1, et d3>0.
 beq	h_line	; Ligne horizontale?
 add.w	d3,d7	; d7=nbr de lignes.
 moveq.l	#$0,d6	; On va remplir les xmins en sens inverse.
 move.w	d3,d6	; Pour cela on pointe sur la fin du tableau.
 lsl.l	#$2,d6	; 4 octets pour storer un xmin.
 addq.l	#$4,d6	; Penser au -(a1).
 add.l	d6,a1	; a1 pointe sur la fin du tableau.
 add.w	d3,d1	; On commence par le y2.
 add.w	d2,d0	; Ainsi que par x2.
 move.w	d1,d4	; On multiplie y2 par 160, mais
 lsl.w	#$2,d1	; en evitant les mulu pour avoir
 add.w	d4,d1	; l'adresse de debut de ligne.
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la bonne ligne.
 move.w	d0,d1	; On cherche a se placer sur le bon mot.
 andi.w	#$fff0,d0	; d0=x1-x1 mod(16).
 sub.w	d0,d1	; d1=x1 mod(16).
 lsr.w	#$1,d0	; On a 8 octets pour 16 pixels.
 add.w	d0,a0	; a0 pointe sur le bon mot.
 moveq.l	#$0,d0	; On a besoin du upperword du motif.
 add.w	d1,d1	; On met ensuite le motif de depart dans
 move.w	(a2,d1.w),d0	; d0, en sachant que 1 motif=1 mot.
 move.l	#-$a0,d1	; d1=-160, increment pour une ligne.
 cmp.w	d3,d2	; Pente faible ou forte?
 bmi	bad_big

;***********************
; dx>=dy, pente faible.

bad_low:
 move.w	d2,d5	; d5=dx=nbr de points.
 add.w	d3,d3	; d3=2*dy.
 move.w	d3,d4	; d4=Erreur.
 sub.w	d2,d4	; E=2*dy-dx.
 add.w	d2,d2	; d2=2*dx.
 subq.w	#$1,d5	; A cause du dbra.

bad_lowline:		; La routine de ligne pour ce cas.
 tst.w	d4	; Erreur positive?
 bgt.s	bad_low_epos	
bad_low_eneg:		; Erreur negative.
 add.w	d3,d4 	; E=E+2*dy.
 add.l	d0,d0	; Nouveau motif, un pixel plus a gauche.
 addq.w	#$1,d0	; Bit rentrant a 1.
 bmi.s	bad_low_xneg	; Motif completement rempli?
bad_low_plot:
 dbra	d5,bad_lowline	; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

bad_low_epos:		; Erreur positive.
 sub.w	d2,d4	; E=E-2*dx.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.l	d1,a0	; Ligne suivante.
bad_low_eneg2:	; Prochain point sur x.
 add.w	d3,d4 	; E=E+2*dy.
 add.l	d0,d0	; Nouveau motif, un pixel plus a gauche.
 addq.w	#$1,d0	; Bit rentrant a 1.
 bmi.s	bad_low_xneg	; Motif completement rempli?
bad_low_plot2:
 dbra	d5,bad_lowline	; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

bad_low_xneg:		; Changement de motif.
 btst.l	#$10,d0	; Le motif vient d'etre rempli?
 beq.s	bad_low_plot
 moveq.l	#$1,d0	; Non, ca deborde sur le upperword, on
 subq.l	#$8,a0	; change donc de motif et d'adresse.
bad_low_plot3:
 dbra	d5,bad_lowline	; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

;*********************
; dx<dy, pente forte.

bad_big:		; Pente forte.
 move.w	d3,d5	; d5=dy=nbr de points.
 add.w	d2,d2	; d2=2*dx.
 move.w	d2,d4	; d4=Erreur.
 sub.w	d3,d4	; E=2*dx-dy.
 add.w	d3,d3	; d2=2*dy.
 subq.w	#$1,d5	; A cause du dbra.

bad_bigline:		; La routine de ligne pour ce cas.
 tst.w	d4	; Erreur positive?
 bgt.s	bad_big_epos	
bad_big_eneg:		; Erreur negative.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
bad_big_plot:
 dbra	d5,bad_bigline	; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

bad_big_epos:		; Erreur positive.
 sub.w	d3,d4	; E=E-2*dy.
 add.l	d0,d0	; Nouveau motif, un pixel plus a gauche.
 addq.w	#$1,d0	; Bit rentrant a 1.
 bmi.s	bad_big_xneg	; Motif deborde sur le upperword?
bad_big_eneg2:	; Prochain point sur y.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
bad_big_plot2:
 dbra	d5,bad_bigline; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

bad_big_xneg:		; Changement de motif.
 btst.l	#$10,d0	; Le motif vient d'etre rempli?
 beq.s	bad_big_plot
 moveq.l	#$1,d0	; Non, ca deborde sur le upperword, on
 subq.l	#$8,a0	; change donc de motif et d'adresse.
bad_big_eneg3:	; Prochain point sur y.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
bad_big_plot3:
 dbra	d5,bad_bigline; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmins.
 move.w	a0,-(a1)	; Adresse dans tableau des xmins.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

;*******
; dy=0.

h_line:
 move.w	d1,d4	; On multiplie y1 par 160, mais
 lsl.w	#$2,d1	; en evitant les mulu pour avoir
 add.w	d4,d1	; l'adresse de debut de ligne.
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la bonne ligne.
 move.w	d0,d1	; On cherche a se placer sur le bon mot.
 andi.w	#$fff0,d0	; d0=x1-x1 mod(16).
 sub.w	d0,d1	; d1=x1 mod(16).
 lsr.w	#$1,d0	; On a 8 octets pour 16 pixels.
 add.w	d0,a0	; a0 pointe sur le bon mot.
 moveq.l	#$0,d0	; On a besoin du upperword du motif.
 add.w	d1,d1	; On met ensuite le motif de depart dans
 move.w	(a2,d1.w),d0	; d0, en sachant que 1 motif=1 mot.
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 rts

 	
 	
;************************
; x1=x2 Ligne verticale.
;************************

xmin_ver:
 sub.w	d1,d3	; d3=y2-y1, et dans ce cas d3>0.
 add.w	d3,d7	; d7=nbr de lignes.
 move.w	d1,d4	; On multiplie y1 par 160, mais
 lsl.w	#$2,d1	; en evitant les mulu pour avoir
 add.w	d4,d1	; l'adresse de debut de ligne.
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la bonne ligne.
 move.w	d0,d1	; On cherche a se placer sur le bon mot.
 andi.w	#$fff0,d0	; d0=x1-x1 mod(16).
 sub.w	d0,d1	; d1=x1 mod(16).
 lsr.w	#$1,d0	; On a 8 octets pour 16 pixels.
 add.w	d0,a0	; a0 pointe sur le bon mot.
 moveq.l	#$0,d0	; On a besoin du upperword du motif.
 add.w	d1,d1	; On met ensuite le motif de depart dans
 move.w	(a2,d1.w),d0	; d0, en sachant que 1 motif=1 mot.
 move.l	#$a0,d1	; d1=160, increment pour une ligne.
ver_line:
 move.w	a0,(a1)+	; Adresse dans tableau des xmins.
 move.w	d0,(a1)+	; Motif dans tableau des xmins.
 add.w	d1,a0
 dbra	d3,ver_line
 rts


min_word:
 dc.w	%1111111111111111
 dc.w	%1111111111111110
 dc.w	%1111111111111100
 dc.w	%1111111111111000
 dc.w	%1111111111110000
 dc.w	%1111111111100000
 dc.w	%1111111111000000
 dc.w	%1111111110000000
 dc.w	%1111111100000000
 dc.w	%1111111000000000
 dc.w	%1111110000000000
 dc.w	%1111100000000000
 dc.w	%1111000000000000
 dc.w	%1110000000000000
 dc.w	%1100000000000000
 dc.w	%1000000000000000


;*******************
; Calcul des Xmaxs.
;*******************
; Appel:
;   d0.w = x1.
;   d1.w = y1.
;   d2.w = x2.
;   d3.w = y2.
;   a0.l = adresse ramvideo.
;   a1.l = adresse sauvegarde.
; Sortie:
;   d7.w = d7.w + nbr_lignes -1.
;   (a1) = adresse.w + motif.w.

xmax:
 move.l	#max_word,a2
 sub.w	d0,d2	; d2=y2-y1.
 beq	xmax_ver	; Ligne verticale?
 bpl	xmax_mbad	; x2>x1?


;**************************
; x1>x2 Traitement normal.
;**************************

xmax_mok:
 neg.w	d2	; d2=abs(x2-x1).
 sub.w	d1,d3	; d3=y2-y1, et dans ce cas d3>0.
 add.w	d3,d7	; d7=nbr de lignes.
 move.w	d1,d4	; On multiplie y1 par 160, mais
 lsl.w	#$2,d1	; en evitant les mulu pour avoir
 add.w	d4,d1	; l'adresse de debut de ligne.
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la bonne ligne.
 move.w	d0,d1	; On cherche a se placer sur le bon mot.
 andi.w	#$fff0,d0	; d0=x1-x1 mod(16).
 sub.w	d0,d1	; d1=x1 mod(16).
 lsr.w	#$1,d0	; On a 8 octets pour 16 pixels.
 add.w	d0,a0	; a0 pointe sur le bon mot.
 moveq.l	#$0,d0	; On a besoin du upperword du motif.
 add.w	d1,d1	; On met ensuite le motif de depart dans
 move.w	(a2,d1.w),d0	; d0, en sachant que 1 motif=1 mot.
 move.l	#$a0,d1	; d1=160, increment pour une ligne.
 cmp.w	d3,d2	; Pente faible ou forte?
 bmi	mok_big

;***********************
; dx>=dy, pente faible.

mok_low:
 move.w	d2,d5	; d5=dx=nbr de points.
 add.w	d3,d3	; d3=2*dy.
 move.w	d3,d4	; d4=Erreur.
 sub.w	d2,d4	; E=2*dy-dx.
 add.w	d2,d2	; d2=2*dx.
 subq.w	#$1,d5	; A cause du dbra.

mok_lowline:		; La routine de ligne pour ce cas.
 tst.w	d4	; Erreur positive?
 bgt.s	mok_low_epos	
mok_low_eneg:		; Erreur negative.
 add.w	d3,d4 	; E=E+2*dy.
 add.w	d0,d0	; Nouveau motif, un pixel plus a gauche.
 beq.s	mok_low_xnul	; Motif completement vide?
mok_low_plot:
 dbra	d5,mok_lowline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 rts

mok_low_epos:		; Erreur positive.
 sub.w	d2,d4	; E=E-2*dx.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 add.l	d1,a0	; Ligne suivante.
mok_low_eneg2:		; Prochain point sur x.
 add.w	d3,d4 	; E=E+2*dy.
 add.w	d0,d0	; Nouveau motif, un pixel plus a gauche.
 beq.s	mok_low_xnul	; Motif completement vide?
mok_low_plot2:
 dbra	d5,mok_lowline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 rts

mok_low_xnul:		; Changement de motif.
 move.w	#$ffff,d0	; Motif de depart.
 subq.l	#$8,a0	; Change d'adresse.
mok_low_plot3:
 dbra	d5,mok_lowline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 rts

;*********************
; dx<dy, pente forte.

mok_big:		; Pente forte.
 move.w	d3,d5	; d5=dy=nbr de points.
 add.w	d2,d2	; d2=2*dx.
 move.w	d2,d4	; d4=Erreur.
 sub.w	d3,d4	; E=2*dx-dy.
 add.w	d3,d3	; d2=2*dy.
 subq.w	#$1,d5	; A cause du dbra.

mok_bigline:		; La routine de ligne pour ce cas.
 tst.w	d4	; Erreur positive?
 bgt.s	mok_big_epos	
mok_big_eneg:		; Erreur negative.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
mok_big_plot:
 dbra	d5,mok_bigline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 rts

mok_big_epos:		; Erreur positive.
 sub.w	d3,d4	; E=E-2*dy.
 add.w	d0,d0	; Nouveau motif, un pixel plus a gauche.
 beq.s	mok_big_xnul	; Motif completement vide?
mok_big_eneg2:		; Prochain point sur y.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
mok_big_plot2:
 dbra	d5,mok_bigline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 rts

mok_big_xnul:		; Changement de motif.
 move.w	#$ffff,d0	; Motif de depart.
 subq.l	#$8,a0	; Change d'adresse.
mok_big_eneg3:		; Prochain point sur y.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
mok_big_plot3:
 dbra	d5,mok_bigline	; Prochain point.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 rts



;***************************
; x1<x2 Traitement inverse.
;***************************

xmax_mbad:
 sub.w	d1,d3	; d3=y2-y1, et d3>0.
 beq	mh_line	; Ligne horizontale?
 add.w	d3,d7	; d7=nbr de lignes.
 moveq.l	#$0,d6	; On va remplir les xmaxs en sens inverse.
 move.w	d3,d6	; Pour cela on pointe sur la fin du tableau.
 lsl.l	#$2,d6	; 4 octets pour storer un xmax.
 addq.l	#$4,d6	; Penser au -(a1).
 add.l	d6,a1	; a1 pointe sur la fin du tableau.
 add.w	d3,d1	; On commence par le y2.
 add.w	d2,d0	; Ainsi que par x2.
 move.w	d1,d4	; On multiplie y2 par 160, mais
 lsl.w	#$2,d1	; en evitant les mulu pour avoir
 add.w	d4,d1	; l'adresse de debut de ligne.
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la bonne ligne.
 move.w	d0,d1	; On cherche a se placer sur le bon mot.
 andi.w	#$fff0,d0	; d0=x1-x1 mod(16).
 sub.w	d0,d1	; d1=x1 mod(16).
 lsr.w	#$1,d0	; On a 8 octets pour 16 pixels.
 add.w	d0,a0	; a0 pointe sur le bon mot.
 add.w	d1,d1	; On met ensuite le motif de depart dans
 move.w	(a2,d1.w),d0	; d0, en sachant que 1 motif=1 mot.
 move.l	#-$a0,d1	; d1=-160, increment pour une ligne.
 cmp.w	d3,d2	; Pente faible ou forte?
 bmi	mbad_big

;***********************
; dx>=dy, pente faible.

mbad_low:
 move.w	d2,d5	; d5=dx=nbr de points.
 add.w	d3,d3	; d3=2*dy.
 move.w	d3,d4	; d4=Erreur.
 sub.w	d2,d4	; E=2*dy-dx.
 add.w	d2,d2	; d2=2*dx.
 subq.w	#$1,d5	; A cause du dbra.

mbad_lowline:		; La routine de ligne pour ce cas.
 tst.w	d4	; Erreur positive?
 bgt.s	mbad_low_epos	
mbad_low_eneg:		; Erreur negative.
 add.w	d3,d4 	; E=E+2*dy.
 add.w	d0,d0	; Nouveau motif, un pixel plus a gauche.
 beq.s	mbad_low_xnul	; Motif completement vide?
mbad_low_plot:
 dbra	d5,mbad_lowline	; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

mbad_low_epos:		; Erreur positive.
 sub.w	d2,d4	; E=E-2*dx.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.l	d1,a0	; Ligne suivante.
mbad_low_eneg2:	; Prochain point sur x.
 add.w	d3,d4 	; E=E+2*dy.
 add.w	d0,d0	; Nouveau motif, un pixel plus a gauche.
 beq.s	mbad_low_xnul	; Motif completement vide?
mbad_low_plot2:
 dbra	d5,mbad_lowline	; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

mbad_low_xnul:		; Changement de motif.
 move.w	#$ffff,d0	; Motif de depart.
 subq.l	#$8,a0	; Change d'adresse.
mbad_low_plot3:
 dbra	d5,mbad_lowline	; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

;*********************
; dx<dy, pente forte.

mbad_big:		; Pente forte.
 move.w	d3,d5	; d5=dy=nbr de points.
 add.w	d2,d2	; d2=2*dx.
 move.w	d2,d4	; d4=Erreur.
 sub.w	d3,d4	; E=2*dx-dy.
 add.w	d3,d3	; d2=2*dy.
 subq.w	#$1,d5	; A cause du dbra.

mbad_bigline:		; La routine de ligne pour ce cas.
 tst.w	d4	; Erreur positive?
 bgt.s	mbad_big_epos	
mbad_big_eneg:		; Erreur negative.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
mbad_big_plot:
 dbra	d5,mbad_bigline	; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

mbad_big_epos:		; Erreur positive.
 sub.w	d3,d4	; E=E-2*dy.
 add.w	d0,d0	; Nouveau motif, un pixel plus a gauche.
 beq.s	mbad_big_xnul	; Motif completement vide?
mbad_big_eneg2:	; Prochain point sur y.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
mbad_big_plot2:
 dbra	d5,mbad_bigline; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

mbad_big_xnul:		; Changement de motif.
 move.w	#$ffff,d0	; Motif de depart.
 subq.l	#$8,a0	; Change d'adresse.
mbad_big_eneg3:	; Prochain point sur y.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.w	d2,d4 	; E=E+2*dx.
 add.w	d1,a0	; On passe a la ligne suivante.
mbad_big_plot3:
 dbra	d5,mbad_bigline; Prochain point.
 move.w	d0,-(a1)	; Motif dans tableau des xmaxs.
 move.w	a0,-(a1)	; Adresse dans tableau des xmaxs.
 add.l	d6,a1	; On se replace en fin de tableau.
 rts

;*******
; dy=0.

mh_line:
 add.w	d2,d0	; Motif de fin.
 move.w	d1,d4	; On multiplie y1 par 160, mais
 lsl.w	#$2,d1	; en evitant les mulu pour avoir
 add.w	d4,d1	; l'adresse de debut de ligne.
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la bonne ligne.
 move.w	d0,d1	; On cherche a se placer sur le bon mot.
 andi.w	#$fff0,d0	; d0=x1-x1 mod(16).
 sub.w	d0,d1	; d1=x1 mod(16).
 lsr.w	#$1,d0	; On a 8 octets pour 16 pixels.
 add.w	d0,a0	; a0 pointe sur le bon mot.
 moveq.l	#$0,d0	; On a besoin du upperword du motif.
 add.w	d1,d1	; On met ensuite le motif de depart dans
 move.w	(a2,d1.w),d0	; d0, en sachant que 1 motif=1 mot.
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 rts

 	
 	
;************************
; x1=x2 Ligne verticale.
;************************

xmax_ver:
 sub.w	d1,d3	; d3=y2-y1, et dans ce cas d3>0.
 add.w	d3,d7	; d7=nbr de lignes.
 move.w	d1,d4	; On multiplie y1 par 160, mais
 lsl.w	#$2,d1	; en evitant les mulu pour avoir
 add.w	d4,d1	; l'adresse de debut de ligne.
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la bonne ligne.
 move.w	d0,d1	; On cherche a se placer sur le bon mot.
 andi.w	#$fff0,d0	; d0=x1-x1 mod(16).
 sub.w	d0,d1	; d1=x1 mod(16).
 lsr.w	#$1,d0	; On a 8 octets pour 16 pixels.
 add.w	d0,a0	; a0 pointe sur le bon mot.
 moveq.l	#$0,d0	; On a besoin du upperword du motif.
 add.w	d1,d1	; On met ensuite le motif de depart dans
 move.w	(a2,d1.w),d0	; d0, en sachant que 1 motif=1 mot.
 move.l	#$a0,d1	; d1=160, increment pour une ligne.
mver_line:
 move.w	a0,(a1)+	; Adresse dans tableau des xmaxs.
 move.w	d0,(a1)+	; Motif dans tableau des xmaxs.
 add.w	d1,a0
 dbra	d3,mver_line
 rts


max_word:
 dc.w	%1000000000000000
 dc.w	%1100000000000000
 dc.w	%1110000000000000
 dc.w	%1111000000000000
 dc.w	%1111100000000000
 dc.w	%1111110000000000
 dc.w	%1111111000000000
 dc.w	%1111111100000000
 dc.w	%1111111110000000
 dc.w	%1111111111000000
 dc.w	%1111111111100000
 dc.w	%1111111111110000
 dc.w	%1111111111111000
 dc.w	%1111111111111100
 dc.w	%1111111111111110
 dc.w	%1111111111111111
