
; **************************************
; ****** Programme de Compression ******
; **************************************

image		equ	$f8000

main_proggy:
 move.l		#codage,a0	; On commence par vider la BSS.
 move.l		#end_bss,d0	; Pour cela on calcule la
 sub.l		a0,d0		; longueur de cette derniere.
clear_bss:
 move.b		#$0,(a0)+	; On clear un byte.
 subq.l		#$1,d0		; Est t'on au dernier byte?
 bne		clear_bss

 move.l		#image,a0
 move.l		#$7cff,d0
clear_screen:
 move.b		#$0,(a0)+
 dbra		d0,clear_screen

 move.w		#$0,-(sp)
 pea		fname
 move.w		#$3d,-(sp)
 trap		#1		; On ouvre le fichier.
 addq.l		#8,sp
 move.w		d0,d7		; On sauve le handle.

 pea		nbpackedbits	; Le premier lmot du fichier
 move.l		#4,-(sp)	; contient le nb de bits packes.
 move.w		d7,-(sp)	; Il va servir pour la lecture
 move.w		#$3f,-(sp)	; du fichier.
 trap		#1
 add.l		#12,sp

 pea		nbbits_rept	; Le lmot suivant contient
 move.l		#4,-(sp)	; le nb de bits pour les rept
 move.w		d7,-(sp)	; utilise pour packer l'image.
 move.w		#$3f,-(sp)	
 trap		#1
 add.l		#12,sp

 move.l		nbpackedbits,d6	; On calcule le nb de bytes de
 lsr.l		#$3,d6		; l'image packee.
 addq.l		#$1,d6

 pea		codage		; On lit cette derniere.
 move.l		d6,-(sp)
 move.w		d7,-(sp)
 move.w		#$3f,-(sp)
 trap		#1
 add.l		#12,sp

 move.w		d7,-(sp)	; Puis on ferme le fichier.
 move.w		#$3e,-(sp)
 trap		#1
 addq.l		#4,sp

boucle1:
 move.l		#$1,d6		; On decode un bit.
 jsr		decode_sthing
 cmpi.l		#$1,d7		; Si on a 1 on va a condition1.
 beq		condition1

condition0:
 move.l		#$4,d6
 jsr		decode_sthing	; On decode quatre bits.
 move.l		d7,pixel_color
viewed:
 move.l		xcomp,d6	; On regarde si on a deja vu le pixel.
 move.l		ycomp,d7
 jsr		pixel_viewed
 cmpi.l		#$0,d7
 beq		cont_c0
 addi.l		#$1,xcomp	; On incremente x.
 cmpi.l		#320,xcomp	; Fin de la ligne?
 bne		pas_fin_ligne
 move.l		#$0,xcomp
 addi.l		#$1,ycomp	; On incremente y.
 cmpi.l		#200,ycomp	; Fin de l'image?
 beq		fin_boucle1	
pas_fin_ligne:
 jmp		viewed
cont_c0:
 move.l		pixel_color,d5
 move.l		xcomp,d6
 move.l		ycomp,d7
 jsr		put_pixel_color

 move.l		xcomp,d6
 move.l		ycomp,d7
 jsr		signal_viewed_pixel
 move.l		xcomp,x2
 move.l		ycomp,y2
 jmp		boucle1

condition1:
 move.l		#$3,d6		; Prendre 3 bits dans codage.
 jsr		decode_sthing
 move.l		d7,dir
 move.l		nbbits_rept,d6	; Prendre nbbits_rept bits.
 jsr		decode_sthing
 move.l		d7,d0

 move.l		#direction,a0
 move.l		dir,d1
 lsl.l		#$3,d1		; Multiplication par 8.
 add.l		d1,a0
 move.l		(a0)+,d2
 move.l		(a0),d3

 subq.l		#$1,d0
boucle2:
 add.l		d2,x2		; x2=x2+direction.
 add.l		d3,y2		; y2=y2+direction.
 move.l		x2,d6
 move.l		y2,d7
 jsr		pixel_viewed
 cmpi.l		#$1,d7
 beq		boucle2

 move.l		x2,d6
 move.l		y2,d7
 move.l		pixel_color,d5
 jsr		put_pixel_color
 move.l		x2,d6
 move.l		y2,d7
 jsr		signal_viewed_pixel
 dbra		d0,boucle2
 jmp		boucle1

fin_boucle1:
 clr.w		-(sp)
 trap		#1











; *************
; Sous Routines
; **************

; Cette routine doit etre appele avec les parametres suivants:
;	d5=pixel_color		(quartet, le reste a 0)
;	d6=X			(word, mais upperword a 0)
;	d7=Y			(word, mais upperword a 0)
; Elle retourne le parametre:
;	d7=pixel_color(X,Y)	(quartet et le reste a 0)
; Elle utilise aussi:
;	a6			(long)

put_pixel_color:
 move.l		#image,a6	; On utilise a6 pour l'adresse des pixels.
 mulu.w		#$a0,d7		; Chaque ligne fait 160 bytes.
 add.l		d7,a6		; On se rapproche du pixel qu'on veut.
 move.l		d6,d7		; Il reste encore les x.
 and.b		#$f0,d7		; On met le dernier quartet a 0.
 sub.l		d7,d6		; Pour avoir d6=x mod(16).
 ror.l		#$1,d7		; On divise d7 par 16(nb pixels),et on
 add.l		d7,a6		; le multiplie par 8(4 bitplans*2 bytes).
; not.l		d6		;*************************.
; add.l		#$f,d6		;*************************.
 cmpi.b		#$8,d6		; Pb: les bset ne se font que sur des bytes.
 blt.s		ptest_bit_0	; Donc si x mod(16)<8,on ne change rien.
psecond_byte:
 subq.l		#$8,d6		; Si tel n'est pas le cas,on passe
 addq.l		#$1,a6		; au second byte.
ptest_bit_0:
 not.l		d6		;*************************.
 add.l		#$8,d6		;*************************.

 btst.l		#$0,d5		; Ce bit est il allume?
 beq.s		ptest_bit_1	; Non alors on continue avec le bit suivant.
pset_bit_0:			; Si oui, alors
 bset.b		d6,(a6)		; on set le bit correspondant dans d7.
ptest_bit_1:
 btst.l		#$1,d5		; Et on recommence avec les autres bits.
 beq.s		ptest_bit_2
pset_bit_1:
 bset.b		d6,$2(a6)
ptest_bit_2:
 btst.l		#$2,d5		; ...
 beq.s		ptest_bit_3
pset_bit_2:
 bset.b		d6,$4(a6)
ptest_bit_3:
 btst.l		#$3,d5		; ..
 beq.s		pend_test_bit
pset_bit_3:
 bset.b		d6,$6(a6)
pend_test_bit:
 rts				; d7 contient pixel_color, ciao.


; ******  ******
; Cette routine doit etre appele avec les parametres suivants:
;	d6=X			(word, mais upperword a 0)
;	d7=Y			(word, mais upperword a 0)
; Elle retourne le parametre:
;	d7=viewed_pixels(X,Y)	(bit et le reste a 0)
; Elle utilise aussi:
;	a6			(long)

pixel_viewed:
 move.l		#viewed_pixels,a6
 mulu.w		#$28,d7		; 320 bits par lignes. (40 bytes)
 add.l		d7,a6		; a6 va servir de pointeur.
 move.l		d6,d7
 and.b		#$f8,d7		; d7=x-(x mod(8)).
 sub.l		d7,d6		; d6=x mod(8).
 lsr.l		#$3,d7		; On divise d7 par 8. (8 bits par byte)
 add.l		d7,a6		; a6 pointe sur le byte interessant.
 moveq.l	#$0,d7		; d7 va contenir le resultat.
 btst.b		d6,(a6)		; Le pixel a deja ete vu?
 beq		fin_pv		; Si non on sort.
 moveq.l	#$1,d7		; Si oui, on le signale et on sort.
fin_pv:
 rts

; ******  ******
; Cette routine doit etre appele avec les parametres suivants:
;	d6=X			(word, mais upperword a 0)
;	d7=Y			(word, mais upperword a 0)
; Elle met un 1 dans viewed_pixels(X,Y).
; Elle utilise aussi:
;	a6			(long)

signal_viewed_pixel:
 move.l		#viewed_pixels,a6
 mulu.w		#$28,d7		; 40 bytes par ligne.
 add.l		d7,a6		; a6 va servir de pointeur.
 move.l		d6,d7
 and.b		#$f8,d7		; d7=x-(x mod(8)).
 sub.l		d7,d6		; d6=x mod(8).
 lsr.l		#$3,d7		; On divise d7 par 8. (8 bits par byte)
 add.l		d7,a6		; a6 pointe sur le byte interessant.
 bset.b		d6,(a6)		; On indique que le pixel est deja vu.
 rts				; Trois petits tours et on s'en va.

; ******  ******
; Cette routine doit etre appele avec les parametres suivants:
;	d6=nbbits to decode	(long)
; Elle decode d6 bits et les mets dans d7.
; Elle utilise aussi:
;	d5,a6

decode_sthing:
 move.l		#codage,a6	; a6 sert de pointeur.
 move.l		nbbitsread,d5	; Nb de bits deja lus.
 add.l		d6,nbbitsread	; On va lire d6 bits.
 move.l		d5,d7		; On cherche a mettre dans a6
 lsr.l		#$3,d7		; l' adresse a partir de laquelle
 add.l		d7,a6		; lire les donnees.
 lsl.l		#$3,d7		; Puis on met dans d5 nbbitsread mod(8).
 sub.l		d7,d5
 moveq.l	#$0,d7		; On mettra dans d7 ce qui est lu.
 subq.l		#$1,d6		; A cause du dbra.
decode_one_bit:
 btst.b		d5,(a6)		; On teste un bit.
 beq		bit_nul		; Est-il a zero?
 bset		d6,d7		; Si non on set le bit correspondant.
bit_nul:
 addq.l		#$1,d5		; Doit on passer au byte superieur
 cmpi.l		#$8,d5		; dans codage?
 bne		ds_cont
 moveq.l	#$0,d5		; Oui.
 addq.l		#$1,a6
ds_cont:			; On passe au bit suivant.
 dbra		d6,decode_one_bit
 rts





; ************
  Section Data
; ************

direction:
 dc.l		1,0		; A droite.	
 dc.l		0,1		; En bas.
 dc.l		-1,0		; ...
 dc.l		0,-1
 dc.l		1,1
 dc.l		-1,1
 dc.l		-1,-1
 dc.l		1,-1

fname:
 dc.b		'a:\packer.img\raytrace.pak'


; ***********
  Section BSS
; ***********

codage:
 ds.b		64000
viewed_pixels:			; Sert pour savoir si un pixel a
 ds.b		8000		; deja ete utilise.
pixel_color:			; Couleur du pixel courant.
 ds.l		1
nbbitsread:			; Nb de bits deja lus.
 ds.l		1
nbrept:
 ds.l		1
xcomp:
 ds.l		1
ycomp:
 ds.l		1
x2:
 ds.l		1
y2:
 ds.l		1
dir:
 ds.l		1
nbbits_rept:
 ds.l		1
nbpackedbits
 ds.l		1

end_bss:
 ds.w		1
