
; **************************************
; ****** Programme de Compression ******
; **************************************

nbbits_rept	equ	8	; Nbbits pour compter les repts (max=16).
screen		equ	$f8000

main_proggy:
 move.l		#codage,a0	; On utilise a0 comme pointeur.
 move.l		#end_bss,d0	; On va calculer avec d0
 sub.l		a0,d0		; la longueur de la Bss.
fill_bss:
 move.b		#$0,(a0)+	; On clear un byte a la fois.
 subq.l		#$1,d0		; Encore combien de bytes?
 bne		fill_bss	; S'il en reste on continue.
find_nbreptmax:
 moveq.l	#$1,d0		; On met 2^0 dans d0.
 move.l		#nbbits_rept,d1	; Il faut multiplier d0 par 2^nbbits_rept.
 rol.l		d1,d0		; On le fait avec une rotation.
 subq.l		#$1,d0		; Puis on enleve 1.
 move.l		d0,nbreptmax	; Par convention nbreptmax=<65535.

move_image:
 move.l		#image,a0
 move.l		#screen,a1
 move.w		#$7cff,d0
fill_screen:
 move.b		(a0)+,(a1)+
 dbra		d0,fill_screen


 move.l	#$0,ycomp	; Compteur des Y.
boucle1:
 move.l	#$0,xcomp	; Compteur des X.
boucle2:
 move.l		xcomp,d6	; On va voir si le pixel en (X;Y)
 move.l		ycomp,d7	; a deja ete vu. Pour cela on fait
 jsr		pixel_viewed	; fait un appel a cette fonction.
 cmpi.l		#$1,d7		; Pixel deja vu?
 beq		finboucle2	; Oui, alors on passe au pixel suivant.

 move.l		xcomp,d6	; Si non, on va prendre la couleur du
 move.l		ycomp,d7	; pixel en (X;Y).
 jsr		get_pixel_color
 move.l		d7,pixel_color	; On sauve la couleur du pixel.

 moveq.l	#$1,d6		; Nb de bits a coder.
 moveq.l	#$0,d7		; Ce qu'il faut coder.
 jsr		code_sthing	; On va mettre 0 sur 1 bit dans codage.

 moveq.l	#$4,d6		; Nb de bits a coder.
 move.l		pixel_color,d7	; Ce qu'il faut coder.
 jsr		code_sthing	; On code pixel_color sur 4 bits.

 move.l		xcomp,d6	; Il faut signaler que ce pixel
 move.l		ycomp,d7	; a ete vu.
 jsr		signal_viewed_pixel

;******
 move.l		#$f,d5
 move.l		xcomp,d6
 move.l		ycomp,d7
 jsr		put_pixel_color
;******


 move.l		xcomp,xnew
 move.l		ycomp,ynew
next_dir:
 move.l		#$0,nbrept_dir
 move.l		#$0,dir
 move.l		#$0,dir_number
boucle3:
 move.l		xnew,d0
 move.l		ynew,d1
 move.l		#$0,nbrept
calcul_nbrept:
 move.l		#direction,a6	; On va ajouter a xdir(d0) 1,0 ou -1
 move.l		dir_number,d7	; suivant la direction.
 rol.l		#$3,d7		; 2 lmots par direction.
 add.l		d7,a6
 add.l		(a6)+,d0	; xdir=xdir+direction.
 add.l		(a6),d1		; ydir=ydir+direction.

 cmpi.l		#$0,d0		; xdir<0?		
 blt		fin_calcul_nbrept
 cmpi.l		#$13f,d0	; xdir>319?
 bgt		fin_calcul_nbrept
 cmpi.l		#$0,d1		; ydir<0?		
 blt		fin_calcul_nbrept
 cmpi.l		#$c7,d1		; ydir>199?
 bgt		fin_calcul_nbrept

 move.l		d0,d6		; On va maintenant regarder
 move.l		d1,d7 		; si viewed_pixel(xdir;ydir)
 jsr		pixel_viewed	; est egal a 1.
 cmpi.l		#$1,d7		; Si le pixel est deja vu
 beq		calcul_nbrept	; on passe au suivant.

 move.l		d0,d6		; On regarde si image(xdir;ydir)
 move.l		d1,d7		; la meme couleur que pixel_color.
 jsr		get_pixel_color	; Si on a pas la meme couleur
 cmp.l		pixel_color,d7	; on arrete.
 bne		fin_calcul_nbrept

 add.l		#$1,nbrept
 move.l		nbreptmax,d7
 cmp.l		nbrept,d7
 beq		fin_calcul_nbrept
 jmp		calcul_nbrept
fin_calcul_nbrept:
 move.l		nbrept_dir,d7
 cmp.l		nbrept,d7
 bge		finboucle3
 move.l		nbrept,nbrept_dir
 move.l		dir_number,dir
finboucle3:
 add.l		#$1,dir_number
 cmpi.l		#$8,dir_number
 bne		boucle3

 move.l		#nbbits_rept,d7
 addq.l		#$3,d7		; Nb de bits pou coder la dir.
 addq.l		#$1,d7		; Bit du header.
 divu.w		#$4,d7		; Nb de bitplans.
 cmp.l		nbrept_dir,d7
 bgt		fin_next_dir

 move.l		#$1,d6		; On met 1 sur 1 bit dans codage.
 move.l		#$1,d7
 jsr		code_sthing

 move.l		#$3,d6		; On code dir sur 3 bits.
 move.l		dir,d7
 jsr		code_sthing

 move.l		#nbbits_rept,d6 ; On met nbrept_dir sur nbbits_rept
 move.l		nbrept_dir,d7	; bits dans codage.
 jsr		code_sthing

 move.l		xnew,d0		; On va remplir viewed_pixel_tab.
 move.l		ynew,d1
 move.l		nbrept_dir,d4
 subq.l		#$1,d4
 move.l		#direction,a0
 move.l		dir,d6
 rol.l		#$3,d6		; 2 lmots par direction.
 add.l		d6,a0
 move.l		(a0)+,d2
 move.l		(a0),d3
fill_vpt:
 add.l		d2,d0
 add.l		d3,d1

 move.l		d0,d6
 move.l		d1,d7
 jsr		pixel_viewed
 cmpi.l		#$1,d7
 beq		fill_vpt

 move.l		d0,d6
 move.l		d1,d7
 jsr		signal_viewed_pixel

;******
 move.l		#$f,d5
 move.l		d0,d6
 move.l		d1,d7
 jsr		put_pixel_color
;******

 dbra		d4,fill_vpt
 move.l		d0,xnew		; (Xnew;Ynew)=(Xnew;Ynew)+
 move.l		d1,ynew		; (direction*nbrept_dir).
 jmp		next_dir

fin_next_dir:

finboucle2:
 addq.l		#$1,xcomp	; Pixel suivant.
 cmpi.l		#$140,xcomp	; On a atteint le pixel 319?
 bne		boucle2		; Non, alors on continue.
finboucle1:
 addq.l		#$1,ycomp	; Ligne suivante.
 cmpi.l		#$c8,ycomp	; On a atteint la ligne 199?
 bne		boucle1		; Non, alors on continue.

save_packedfile:
 move.w		#0,-(sp)
 pea		fname
 move.w		#$3c,-(sp)
 trap		#1
 addq.l		#8,sp
 move.w		d0,d7

 pea		nbpackedbits
 move.l		#$4,-(sp)
 move.w		d7,-(sp)
 move.w		#$40,-(sp)
 trap		#1
 add.l		#12,sp

 move.l		nbpackedbits,d6
 ror.l		#$3,d6
 addq.l		#$1,d6

 move.l		#nbbits_rept,nbpackedbits
 pea		nbpackedbits
 move.l		#$4,-(sp)
 move.w		d7,-(sp)
 move.w		#$40,-(sp)
 trap		#1
 add.l		#12,sp

 pea		codage
 move.l		d6,-(sp)
 move.w		d7,-(sp)
 move.w		#$40,-(sp)
 trap		#1
 add.l		#12,sp

 move.w		d7,-(sp)
 move.w		#$3e,-(sp)
 trap		#1
 addq.l		#4,sp


end_proggy:
 clr.w		-(sp)
 trap		#1





; *************
; Sous Routines
; **************

; Cette routine doit etre appele avec les parametres suivants:
;	d5=pixel_color		(quartet, le reste a 0)
;	d6=X			(word, mais upperword a 0)
;	d7=Y			(word, mais upperword a 0)
; Elle retourne le parametre:
;	d7=pixel_color(X,Y)	(quartet et le reste a 0)
; Elle utilise aussi:
;	a6			(long)

put_pixel_color:
 move.l		#screen,a6	; On utilise a6 pour l'adresse des pixels.
 mulu.w		#$a0,d7		; Chaque ligne fait 160 bytes.
 add.l		d7,a6		; On se rapproche du pixel qu'on veut.
 move.l		d6,d7		; Il reste encore les x.
 and.b		#$f0,d7		; On met le dernier quartet a 0.
 sub.l		d7,d6		; Pour avoir d6=x mod(16).
 ror.l		#$1,d7		; On divise d7 par 16(nb pixels),et on
 add.l		d7,a6		; le multiplie par 8(4 bitplans*2 bytes).
; not.l		d6		;*************************.
; add.l		#$f,d6		;*************************.
 cmpi.b		#$8,d6		; Pb: les bset ne se font que sur des bytes.
 blt.s		ptest_bit_0	; Donc si x mod(16)<8,on ne change rien.
psecond_byte:
 subq.l		#$8,d6		; Si tel n'est pas le cas,on passe
 addq.l		#$1,a6		; au second byte.
ptest_bit_0:
 not.l		d6		;*************************.
 add.l		#$8,d6		;*************************.

 btst.l		#$0,d5		; Ce bit est il allume?
 beq.s		ptest_bit_1	; Non alors on continue avec le bit suivant.
pset_bit_0:			; Si oui, alors
 bset.b		d6,(a6)		; on set le bit correspondant dans d7.
ptest_bit_1:
 btst.l		#$1,d5		; Et on recommence avec les autres bits.
 beq.s		ptest_bit_2
pset_bit_1:
 bset.b		d6,$2(a6)
ptest_bit_2:
 btst.l		#$2,d5		; ...
 beq.s		ptest_bit_3
pset_bit_2:
 bset.b		d6,$4(a6)
ptest_bit_3:
 btst.l		#$3,d5		; ..
 beq.s		pend_test_bit
pset_bit_3:
 bset.b		d6,$6(a6)
pend_test_bit:
 rts				; d7 contient pixel_color, ciao.


; Cette routine doit etre appele avec les parametres suivants:
;	d6=X			(word, mais upperword a 0)
;	d7=Y			(word, mais upperword a 0)
; Elle retourne le parametre:
;	d7=pixel_color(X,Y)	(quartet et le reste a 0)
; Elle utilise aussi:
;	a6			(long)

get_pixel_color:
 move.l		#image,a6	; On utilise a6 pour l'adresse des pixels.
 mulu.w		#$a0,d7		; Chaque ligne fait 160 bytes.
 add.l		d7,a6		; On se rapproche du pixel qu'on veut.
 move.l		d6,d7		; Il reste encore les x.
 and.b		#$f0,d7		; On met le dernier quartet a 0.
 sub.l		d7,d6		; Pour avoir d6=x mod(16).
 ror.l		#$1,d7		; On divise d7 par 16(nb pixels),et on
 add.l		d7,a6		; le multiplie par 8(4 bitplans*2 bytes).
; not.l		d6		;*************************.
; add.l		#$f,d6		;*************************.
 cmpi.b		#$8,d6		; Pb: les btst ne se font que sur des bytes.
 blt.s		gpc_cont	; Donc si x mod(16)<8,on ne change rien.
second_byte:
 subq.l		#$8,d6		; Si tel n'est pas le cas,on passe
 addq.l		#$1,a6		; au second byte.
gpc_cont:
 not.l		d6		;*************************.
 add.l		#$8,d6		;*************************.
 moveq.l	#$0,d7		; d7 va contenir pixel_color.
test_bit_0:
 btst.b		d6,(a6)		; Ce bit est il allume?
 beq.s		test_bit_1	; Non alors on continue avec le bit suivant.
set_bit_0:			; Si oui, alors
 bset.l		#$0,d7		; on set le bit correspondant dans d7.
test_bit_1:
 btst.b		d6,$2(a6)	; Et on recommence avec les autres bits.
 beq.s		test_bit_2
set_bit_1:
 bset.l		#$1,d7
test_bit_2:
 btst.b		d6,$4(a6)	; ...
 beq.s		test_bit_3
set_bit_2:
 bset.l		#$2,d7
test_bit_3:
 btst.b		d6,$6(a6)	; ..
 beq.s		end_test_bit
set_bit_3:
 bset.l		#$3,d7
end_test_bit:
 rts				; d7 contient pixel_color, ciao.

; ******  ******
; Cette routine doit etre appele avec les parametres suivants:
;	d6=X			(word, mais upperword a 0)
;	d7=Y			(word, mais upperword a 0)
; Elle retourne le parametre:
;	d7=viewed_pixels(X,Y)	(bit et le reste a 0)
; Elle utilise aussi:
;	a6			(long)

pixel_viewed:
 move.l		#viewed_pixels,a6
 mulu.w		#$28,d7		; 320 bits par lignes. (40 bytes)
 add.l		d7,a6		; a6 va servir de pointeur.
 move.l		d6,d7
 and.b		#$f8,d7		; d7=x-(x mod(8)).
 sub.l		d7,d6		; d6=x mod(8).
 ror.l		#$3,d7		; On divise d7 par 8. (8 bits par byte)
 add.l		d7,a6		; a6 pointe sur le byte interessant.
 moveq.l	#$0,d7		; d7 va contenir le resultat.
 btst.b		d6,(a6)		; Le pixel a deja ete vu?
 beq		fin_pv		; Si non on sort.
 moveq.l	#$1,d7		; Si oui, on le signale et on sort.
fin_pv:
 rts

; ******  ******
; Cette routine doit etre appele avec les parametres suivants:
;	d6=X			(word, mais upperword a 0)
;	d7=Y			(word, mais upperword a 0)
; Elle met un 1 dans viewed_pixels(X,Y).
; Elle utilise aussi:
;	a6			(long)

signal_viewed_pixel:
 move.l		#viewed_pixels,a6
 mulu.w		#$28,d7		; 40 bytes par ligne.
 add.l		d7,a6		; a6 va servir de pointeur.
 move.l		d6,d7
 and.b		#$f8,d7		; d7=x-(x mod(8)).
 sub.l		d7,d6		; d6=x mod(8).
 ror.l		#$3,d7		; On divise d7 par 8. (8 bits par byte)
 add.l		d7,a6		; a6 pointe sur le byte interessant.
 bset.b		d6,(a6)		; On indique que le pixel est deja vu.
 rts				; Trois petits tours et on s'en va.

; ******  ******
; Cette routine doit etre appele avec les parametres suivants:
;	d6=nbbits to code	(long)
;	d7=thing to code	(nbbits bits, reste a 0)
; Elle met d7 sur d6 bits dans codage.
; Elle utilise aussi:
;	d5,a6

code_sthing:
 move.l		#codage,a6	; a6 sert encore de pointeur.
 move.l		nbpackedbits,d5	; Nb de bits deja packes.
 ror.l		#$3,d5		; d5= nbpackedbits /8.
 add.l		d5,a6		; a6 pointe sur l'endroit ou l'on va coder.
 move.l		nbpackedbits,d5	; Nb de bits deja packes.
 add.l		d6,d5		; d5= nbpackedbits apres les operations.
 move.l		d5,nbpackedbits	; On le sauve pour la prochaine fois.
 sub.l		d6,d5		; On retrouve le nbpackedbits initial.
 and.l		#%111,d5	; d5= nbpackedbits mod(8).
 subq.l		#$1,d6
code_1_bit:
 btst.l		d6,d7		; On lit un bit dans d7.
 beq.s		clear_bit	; On regarde si il est nul.
set_bit:
 bset.b		d5,(a6)		; Si non on set le bit dans codage.
clear_bit:			; Si oui on ne fait rien.
 addq.l		#$1,d5		; On passe au bit suivant.
 cmpi.b		#$8,d5		; Byte suivant?
 bne		end_code_1_bit	; Sinon on passe au bit suivant.
 moveq.l	#$0,d5		; Si oui on inc a6 et on met
 addq.l		#$1,a6		; d5 a 0.
end_code_1_bit:
 dbra		d6,code_1_bit
end_cs:
 rts





; ************
  Section Data
; ************

direction:
 dc.l		1,0		; A droite.	
 dc.l		0,1		; En bas.
 dc.l		-1,0		; ...
 dc.l		0,-1
 dc.l		1,1
 dc.l		-1,1
 dc.l		-1,-1
 dc.l		1,-1

image:
 incbin		'a:\packer.img\raytrace.doo'

fname:
 dc.b		'a:\packer.img\raytrace.pak'


; ***********
  Section BSS
; ***********

codage:
 ds.b		64000
viewed_pixels:			; Sert pour savoir si un pixel a
 ds.b		8000		; deja ete utilise.
pixel_color:			; Couleur du pixel courant.
 ds.l		1
nbpackedbits:			; Nb de bits deja packes.
 ds.l		1
nbreptmax:
 ds.l		1
nbrept_dir:
 ds.l		1
nbrept:
 ds.l		1
xcomp:
 ds.l		1
ycomp:
 ds.l		1
xnew:
 ds.l		1
ynew:
 ds.l		1
xdir:
 ds.l		1
ydir:
 ds.l		1
dir:
 ds.l		1
dir_number:
 ds.l		1


end_bss:
 ds.w		1
